/* -*- Mode: Java; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */

var UnMHTFormatter = {
    format : function (pattern, TITLE, FILENAME, URL, am, pm) {
        var text;
    
        var now = new Date ();
        var YYYY = now.getFullYear ();
        var Y = YYYY % 100;
        var YY = Y >= 10 ? Y : ("0" + Y);
        var M = now.getMonth () + 1;
        var MM = M >= 10 ? M : ("0" + M);
        var D = now.getDate ();
        var DD = D >= 10 ? D : ("0" + D);
        var H = now.getHours ();
        var HH = H >= 10 ? H : ("0" + H);
        var h = now.getHours () % 12;
        var hh = h >= 10 ? h : ("0" + h);
        var m = now.getMinutes ();
        var mm = m >= 10 ? m : ("0" + m);
        var s = now.getSeconds ();
        var ss = s >= 10 ? s : ("0" + s);
        var ampm = H >= 12 ? pm : am;
    
        text = pattern
        .replace (/%YYYY%/g, YYYY)
        .replace (/%YY%/g, YY)
        .replace (/%M%/g, M)
        .replace (/%MM%/g, MM)
        .replace (/%D%/g, D)
        .replace (/%DD%/g, DD)
        .replace (/%H%/g, H)
        .replace (/%HH%/g, HH)
        .replace (/%h%/g, h)
        .replace (/%hh%/g, hh)
        .replace (/%m%/g, m)
        .replace (/%mm%/g, mm)
        .replace (/%s%/g, s)
        .replace (/%ss%/g, ss)
        .replace (/%ampm%/g, ampm)
        .replace (/%TITLE%/g, TITLE)
        .replace (/%FILENAME%/g, FILENAME)
        .replace (/%URL%/g, URL);
    
        return UnMHTFormatter.validateFileName (text);
    },
  
    /**
     * ファイル名に使えない文字を変換する
     *
     * @param  String filename
     *         元のファイル名
     * @return String
     *         変換したファイル名
     */
    validateFileName : function (filename) {
        var re = /\//g;
        if (navigator.appVersion.indexOf ("Windows") != -1) {
            re = /[\\\/\|]/g;
            filename = filename.replace (/\"/g, "'")
                .replace (/[\*\:\?#\!]/g, "_")
                .replace (/</g, "(")
                .replace (/>/g, ")");
        }
        else if (navigator.appVersion.indexOf ("Macintosh") != -1) {
            re = /[\:\/]/g;
        }
        
        filename = filename.replace (re, "_");
        
        return filename;
    }
};
