/* -*- Mode: Java; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */

/**
 * 保存の本体
 */
var UnMHTSaveMulti = {
    messages : null,      /* nsIStringBundle  メッセージ */
    targetWindow : null,  /* nsIWindow  現在のウィンドウ */
    saveFilename : "",    /* String  保存時のファイル名 */
    
    targetDocuments : null, /* Array  対象のドキュメント */
    currentIndex : 0,       /* Number  現在保存中のドキュメントの位置 */
    
    isStopped : false,   /* Boolean  終了したか */
    isCanceled : false,  /* Boolean  キャンセルされたか */ 
    
    defaultMode : -1,    /* Number  同名のファイルがあった場合にどうするか
                          *  -1:  未定義
                          *   0:  上書きする
                          *   1:  名前を変える */
    
    dialog : null,              /* XULElement  ダイアログ */
    acceptButton : null,        /* XULElement  OK ボタン */
    cancelButton : null,        /* XULElement  キャンセルボタン */
    saveButton : null,          /* XULElement  保存ボタン */
    
    saveFilenameCustom : "",    /* String  カスタムファイル名テンプレート */
    saveFilenameCustomAM : "",  /* String  カスタムファイル名テンプレート a.m. */
    saveFilenameCustomPM : "",  /* String  カスタムファイル名テンプレート p.m. */
    
    /**
     * 初期化処理
     */
    init : function () {
        UnMHTSaveMulti.messages
        = Components.classes ["@mozilla.org/intl/stringbundle;1"]
        .getService (Components.interfaces.nsIStringBundleService)
        .createBundle ("chrome://unmht/locale/unmht.properties");
        
        var arg = window.arguments [0];
        
        UnMHTSaveMulti.targetWindow = arg [0];
        UnMHTSaveMulti.saveFilename = arg [1];
        
        UnMHTSaveMulti.targetDocuments = new Array ();
        UnMHTSaveMulti.currentIndex = 0;
        
        UnMHTSaveMulti.dialog
        = document.getElementById ("unmhtSaveMultiDialog"),
        UnMHTSaveMulti.acceptButton
        = UnMHTSaveMulti.dialog.getButton ("accept");
        UnMHTSaveMulti.cancelButton
        = UnMHTSaveMulti.dialog.getButton ("cancel");
        
        UnMHTSaveMulti.saveButton
        = document.getElementById ("save").disabled;
        
        UnMHTSaveMulti.acceptButton.disabled = true;
        UnMHTSaveMulti.isStopped = true;
        
        var value;
        var base = "";
        try {
            var prefBranch
                = Components.classes ["@mozilla.org/preferences-service;1"]
                .getService (Components.interfaces.nsIPrefBranch);
            if (prefBranch.prefHasUserValue ("unmht.savemulti.base")) {
                value
                    = prefBranch.getCharPref ("unmht.savemulti.base");
                base = unescape (value);
            }

            var prefBranch
                = Components.classes ["@mozilla.org/preferences-service;1"]
                .getService (Components.interfaces.nsIPrefBranch);
            if (prefBranch.prefHasUserValue ("unmht.save.filename.custom")) {
                value
                    = prefBranch.getCharPref ("unmht.save.filename.custom");
                UnMHTSaveMulti.saveFilenameCustom = unescape (value);
            }
            
            var prefBranch
                = Components.classes ["@mozilla.org/preferences-service;1"]
                .getService (Components.interfaces.nsIPrefBranch);
            if (prefBranch.prefHasUserValue ("unmht.save.filename.custom.am")) {
                value
                    = prefBranch.getCharPref ("unmht.save.filename.custom.am");
                UnMHTSaveMultiAM.saveFilenameCustom = unescape (value);
            }
            
            var prefBranch
                = Components.classes ["@mozilla.org/preferences-service;1"]
                .getService (Components.interfaces.nsIPrefBranch);
            if (prefBranch.prefHasUserValue ("unmht.save.filename.custom.pm")) {
                value
                    = prefBranch.getCharPref ("unmht.save.filename.custom.pm");
                UnMHTSaveMultiPM.saveFilenameCustom = unescape (value);
            }
        }
        catch (e) {
        }
        
        if (!base) {
            var dir
                = Components
                .classes ["@mozilla.org/file/directory_service;1"]
                .getService (Components.interfaces.nsIProperties)
                .get ("Home", Components.interfaces.nsIFile);
            base = dir.path;
        }
        
        document.getElementById ("base").value = base;
        
        document.getElementById ("target").value = "this";
        UnMHTSaveMulti.selectItem (document.getElementById ("target"));
        
        document.getElementById ("filename").value
        = UnMHTSaveMulti.saveFilename;
        UnMHTSaveMulti.selectItem (document.getElementById ("filename"));
        
        var lastFormat = "separated";
        try {
            var prefBranch
                = Components.classes ["@mozilla.org/preferences-service;1"]
                .getService (Components.interfaces.nsIPrefBranch);
            
            if (prefBranch.prefHasUserValue ("unmht.savemulti.lastformat")) {
                lastFormat
                    = prefBranch.getCharPref ("unmht.savemulti.lastformat");
            }
        }
        catch (e) {
        }

        var lastType = "current";
        try {
            var prefBranch
                = Components.classes ["@mozilla.org/preferences-service;1"]
                .getService (Components.interfaces.nsIPrefBranch);
            
            if (prefBranch.prefHasUserValue ("unmht.savemulti.type")) {
                lastType = prefBranch.getCharPref ("unmht.savemulti.type");
            }
        }
        catch (e) {
        }
        
        document.getElementById ("saveformat").value = lastFormat;
        UnMHTSaveMulti.selectItem (document.getElementById ("saveformat"));
        
        document.getElementById ("savetype").value = lastType;
        UnMHTSaveMulti.selectItem (document.getElementById ("savetype"));
        
        UnMHTSaveMulti.changeTarget ();
        UnMHTSaveMulti.changeFormat ();
        // UnMHTSaveMulti.changeFilename ();
    },
    
    /**
     * キャンセルボタンのイベント
     */
    cancel : function () {
        if (UnMHTSaveMulti.isStopped) {
            return true;
        }
        
        UnMHTSaveMulti.isCanceled = true;
        UnMHTSave.cancel ();
        
        return false;
    },

    /**
     * 保存ボタンのイベント
     */
    onSave : function () {
        UnMHTSaveMulti.saveButton.disabled = true;
        UnMHTSaveMulti.isCanceled = false;
        UnMHTSave.isCanceled = false;
        UnMHTSaveMulti.isStopped = false;
        
        UnMHTSaveMulti.defaultMode = -1;
        
        var base = document.getElementById ("base").value;
        base = escape (base);
        var prefBranch
        = Components.classes ["@mozilla.org/preferences-service;1"]
        .getService (Components.interfaces.nsIPrefBranch);
        prefBranch.setCharPref
        ("unmht.savemulti.base", base);
        
        document.getElementById ("progress_current").value = "";
        document.getElementById ("progress_current_size").value = "";
        document.getElementById ("progress").value = "0%";
        document.getElementById ("failed_label").value = "";
        document.getElementById ("failed_label2").value = "";
        document.getElementById ("failed_label3").value = "";
        document.getElementById ("failed").hidden = true;
        window.sizeToContent ();
        
        UnMHTSaveMulti.save ();
    },    

    /**
     * 保存する
     */
    save : function () {
        var saveformat = document.getElementById ("saveformat").value;
        try {
            var prefBranch
                = Components.classes ["@mozilla.org/preferences-service;1"]
                .getService (Components.interfaces.nsIPrefBranch);
            
            prefBranch.setCharPref ("unmht.savemulti.lastformat", saveformat);
        }
        catch (e) {
        }
        
        if (saveformat == "separated") {
            if (UnMHTSaveMulti.isCanceled) {
                UnMHTSaveMulti.isStopped = true;
            
                UnMHTSaveMulti.acceptButton.disabled = true;
                UnMHTSaveMulti.cancelButton.disabled = false;
                UnMHTSaveMulti.currentIndex = 0;
                UnMHTSaveMulti.saveButton.disabled = false;
            
                window.sizeToContent ();
                return;
            }
        
            if (UnMHTSaveMulti.currentIndex
                >= UnMHTSaveMulti.targetDocuments.length) {
                UnMHTSaveMulti.isStopped = true;
            
                UnMHTSaveMulti.acceptButton.disabled = false;
                UnMHTSaveMulti.cancelButton.disabled = true;
                UnMHTSaveMulti.currentIndex = 0;
                UnMHTSaveMulti.saveButton.disabled = false;
                
                window.sizeToContent ();
                return;
            }
        
            var targetDocument
            = UnMHTSaveMulti.targetDocuments [UnMHTSaveMulti.currentIndex];
            var listbox = document.getElementById ("target_list");
            var listitem = listbox.getItemAtIndex (UnMHTSaveMulti.currentIndex);
            if (listitem.nodeName.toLowerCase () == "listhead"
                || listitem.nodeName.toLowerCase () == "listcols") {
                UnMHTSaveMulti.currentIndex ++;
                UnMHTSaveMulti.save ();
                return;
            }
            
            if (listitem.firstChild.getAttribute ("value") == "ignore") {
                UnMHTSaveMulti.currentIndex ++;
                UnMHTSaveMulti.save ();
                return;
            }
            
            try {
                var title = targetDocument.title;
                if (title == "") {
                    title = targetDocument.location.href;
                }
            }
            catch (e) {
                /* ドキュメントが閉じられた
                 * 次へ */
                var title = listitem.firstChild.nextSibling.getAttribute ("label");
                listitem.firstChild.nextSibling.setAttribute ("label", "NG");
            
                UnMHTSaveMulti.currentIndex ++;
                UnMHTSaveMulti.save ();
                return;
            }
            
            listitem.firstChild.nextSibling.setAttribute ("label", "> " + title);
        }
        else {
            if (document.getElementById ("filename_base").value == "") {
                /* ファイル名が空 */
                document.getElementById ("filename_base").focus ();
                
                return;
            }
        }
        
        var savetype;
        savetype = document.getElementById ("savetype").value;
        try {
            var prefBranch
                = Components.classes ["@mozilla.org/preferences-service;1"]
                .getService (Components.interfaces.nsIPrefBranch);
            
            prefBranch.setCharPref ("unmht.savemulti.type", savetype);
        }
        catch (e) {
        }
        
        var useCurrentState = (savetype == "current");
        
        var file = UnMHTSaveMulti.getFile (targetDocument);
        if (file == null) {
            return;
        }
        
        if (saveformat == "separated") {
            UnMHTSave.initWith (file, useCurrentState,
                                targetDocument.location.href,
                                targetDocument.title,
                                UnMHTSaveMulti.dialog, 2);
            
            UnMHTSave.addDocument
            (targetDocument, targetDocument.location.href,
             useCurrentState, false, null);
        }
        else {
            var subject = document.getElementById ("filename_base").value;
            targetDocument = UnMHTSaveMulti.targetDocuments [0];
            UnMHTSave.initWith (file, useCurrentState,
                                targetDocument.location.href,
                                subject,
                                UnMHTSaveMulti.dialog, 2);
            
            var content;
            content
            = "<?xml version=\"1.0\" encoding=\"Shift_JIS\"?>\n"
            + "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\" \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">\n"
            + "<html lang=\"ja\" xmlns=\"http://www.w3.org/1999/xhtml\" xml:lang=\"ja\">\n"
            + "<head>\n"
            + "<meta http-equiv=\"Content-Type\" content=\"text/html; charset=UTF-8\" />\n"
            + "<title>index</title>\n"
            + "</head>\n"
            + "<body>\n";
            + "<ul>\n";
            
            var locations = Object ();
            var listbox = document.getElementById ("target_list");
            for (var i = 0; i < UnMHTSaveMulti.targetDocuments.length; i ++) {
                var listitem
                    = listbox.getItemAtIndex (i);
                var labelNode = listitem.firstChild.nextSibling;
                try {
                    var targetDocument
                        = UnMHTSaveMulti.targetDocuments [i];
                    
                    var locationBase = targetDocument.location.href;
                    var locationExt = "";
                    if (locationBase.match (/^(.+)(\.[^\/\.]+)$/)) {
                        locationBase = RegExp.$1;
                        locationExt = RegExp.$2;
                    }
                    var location = locationBase + locationExt;
                    
                    if (location in locations) {
                        /* 同じ URI のタブがある場合 */
                        if (useCurrentState) {
                            /* 現在の状態を保存する場合には
                             * 別々に保存する */
                            var n = 1;
                            while (location in locations) {
                                n ++;
                                location = locationBase + n + locationExt;
                            }
                            locations [location] = 1;
                            UnMHTSave.addDocument
                                (targetDocument, location,
                                 useCurrentState, false, null);
                        }
                        else {
                            /* 元のファイルを保存する場合には
                             * 使い回す */
                        }
                    }
                    else {
                        locations [location] = 1;
                        UnMHTSave.addDocument
                            (targetDocument, location,
                             useCurrentState, false, null);
                    }
                    
                    var title = targetDocument.title;
                    if (title == "") {
                        title = targetDocument.location.href;
                    }
                    
                    content += 
                        "<li><a class=\"unmht-tabs\" href=\"" + location
                        + "\">" + title + "</a></li>\n";
                    
                    labelNode.setAttribute ("label", "OK: " + title);
                }
                catch (e) {
                    /* ドキュメントが閉じられた
                     * 次へ */
                    labelNode.setAttribute ("label", "NG");
                }
            }
            
            content
            += "</ul>\n"
            + "</body>\n"
            + "</html>\n";
            
            var converter
            = Components.classes
            ["@mozilla.org/intl/scriptableunicodeconverter"]
            .getService (Components.interfaces.nsIScriptableUnicodeConverter);
            converter.charset = "UTF-8";
            content = UnMHTConverter.converter.ConvertFromUnicode (content);
            
            UnMHTSave.addDataDocument (content, "index", "UTF-8", "text/html");
            
            UnMHTSave.addExtraHeader ("X-UnMHT-tabs", "true");
        }
        
        if (UnMHTSave.files.length > 0) {
            setTimeout (UnMHTSave.checkFiles,
                        100);
        }
    },

    /**
     * 保存先のファイルを返す
     *
     * @param  HTMLDocument targetDocument
     *         対象のドキュメント
     */
    getFile : function (targetDocument) {
        var base = document.getElementById ("base").value;
        var filename;
        if (document.getElementById ("saveformat").value == "single") {
            filename = document.getElementById ("filename_base").value;
            filename = UnMHTFormatter.validateFileName (filename);
        }
        else if (document.getElementById ("filename").value == "leafname"
            || document.getElementById ("filename").value == "title"
            || document.getElementById ("filename").value == "custom") {
            filename = UnMHTSaveMulti.getFilename (targetDocument);
        }
        else if (document.getElementById ("filename").value == "sequential") {
            filename = document.getElementById ("filename_base").value;
            filename = UnMHTFormatter.validateFileName (filename);
            filename += "-" + (UnMHTSaveMulti.currentIndex + 1);
        }
        var filenameBase = filename;
        filename += ".mht";
        
        var file
        = Components.classes ["@mozilla.org/file/local;1"]
        .createInstance (Components.interfaces.nsILocalFile);
        try {
            file.initWithPath (base);
        }
        catch (e) {
            /* ディレクトリが不正 */
            UnMHTSaveMulti.isStopped = true;
            UnMHTSaveMulti.saveButton.disabled = false;
            
            document.getElementById ("base").focus ();
            
            return null;
        }
        file.appendRelativePath (filename);
        
        if (file.exists ()) {
            var result = {
                result : 0,
                applyToAll: false,
                rename : false,
                filename : ""
            };
            if (UnMHTSaveMulti.defaultMode == -1) {
                var confirmURL = "chrome://unmht/content/confirm.xul";
                var features = "chrome,dialog,modal,centerscreen";
                /* arg
                 *   0:result, 1:title, 2:message1, 3:message2,
                 *   4:yes, 5:no, 6:abort, 7:rename, 8:applytoall,
                 *   9:filename, 10:base, 11: existMessage1, 12: existMessage2,
                 *   13:message3
                 */
                openDialog (confirmURL, "", features,
                            [result,
                             UnMHTSaveMulti.messages.GetStringFromName ("overwrite_title"),
                             UnMHTSaveMulti.messages.GetStringFromName ("overwrite_pre")
                             + " " + file.path + " "
                             + UnMHTSaveMulti.messages.GetStringFromName ("overwrite_post"),
                             UnMHTSaveMulti.messages.GetStringFromName ("overwrite_post2"),
                             UnMHTSaveMulti.messages.GetStringFromName ("yes"),
                             UnMHTSaveMulti.messages.GetStringFromName ("no"),
                             UnMHTSaveMulti.messages.GetStringFromName ("abort"),
                             UnMHTSaveMulti.messages.GetStringFromName ("rename"),
                             UnMHTSaveMulti.messages.GetStringFromName ("overwrite_all"),
                             filename, base,
                             UnMHTSaveMulti.messages.GetStringFromName ("overwrite_pre"),
                             UnMHTSaveMulti.messages.GetStringFromName ("overwrite_post"),
                             null]);
                
                if (result.applyToAll) {
                    UnMHTSaveMulti.defaultMode = result.result;
                }
            }
            else {
                result.result = UnMHTSaveMulti.defaultMode;
            }
            
            if (result.rename) {
                filename = result.filename;
                var file
                    = Components.classes ["@mozilla.org/file/local;1"]
                    .createInstance (Components.interfaces.nsILocalFile);
                file.initWithPath (base);
                file.appendRelativePath (filename);
            }
            
            if (result.result == "abort") {
                return null;
            }
            else if (result.result == "no") {
                var i = 2;
                while (file.exists ()) {
                    filename = filenameBase + "-" + i + ".mht";
                    var file
                        = Components.classes ["@mozilla.org/file/local;1"]
                        .createInstance (Components.interfaces.nsILocalFile);
                    file.initWithPath (base);
                    file.appendRelativePath (filename);
                    i ++;
                }
            }
        }
        
        return file;
    },
    
    /**
     * 保存完了イベント
     */
    done : function () {
        if (document.getElementById ("saveformat").value == "separated") {
            var targetDocument
            = UnMHTSaveMulti.targetDocuments [UnMHTSaveMulti.currentIndex]
            var title = targetDocument.title;
            if (title == "") {
                title = targetDocument.location.href;
            }
        
            var listbox = document.getElementById ("target_list");
            var listitem = listbox.getItemAtIndex (UnMHTSaveMulti.currentIndex);
            listitem.firstChild.nextSibling.setAttribute
            ("label", "OK: " + title);
        
            UnMHTSaveMulti.currentIndex ++;
            UnMHTSaveMulti.save ();
        }
        else {
            UnMHTSaveMulti.isStopped = true;
            
            UnMHTSaveMulti.acceptButton.disabled = false;
            UnMHTSaveMulti.cancelButton.disabled = true;
            UnMHTSaveMulti.currentIndex = 0;
            UnMHTSaveMulti.saveButton.disabled = false;
            
            window.sizeToContent ();
        }
    },
    
    /**
     * 対象を変更したイベント
     */
    changeTarget : function () {
        var targetWindows = new Array ();
        
        if (document.getElementById ("target").value == "this") {
            targetWindows.push (UnMHTSaveMulti.targetWindow);
        }
        else {
            var entries
            = Components.classes ["@mozilla.org/appshell/window-mediator;1"]
            .getService (Components.interfaces.nsIWindowMediator)
            .getEnumerator ("navigator:browser");
            
            while (entries.hasMoreElements ()) {
                targetWindows.push (entries.getNext ());
            }
        }
        
        var listbox = document.getElementById ("target_list");
        var node = listbox.firstChild;
        while (node) {
            var nextNode = node.nextSibling;
            if (node.nodeName.toLowerCase () == "listhead"
                || node.nodeName.toLowerCase () == "listcols") {
            }
            else {
                listbox.removeChild (node);
            }
            node = nextNode;
        }
        
        UnMHTSaveMulti.targetDocuments = new Array ();
        
        var listitem;
        var listcell;
        for (var i = 0; i < targetWindows.length; i ++) {
            var w = targetWindows [i];
            
            var tabbrowser = w.document.getElementById ("content");
            
            if ("browsers" in tabbrowser) {
                for (var j = 0; j < tabbrowser.browsers.length; j ++) {
                    var targetDocument
                        = tabbrowser.browsers [j].contentDocument;
                    if (UnMHTSaveMulti.isSavable (targetDocument)) {
                        UnMHTSaveMulti.targetDocuments.push (targetDocument);
                    }
                }
            }
            else {
                var targetDocument = tabbrowser.contentDocument;
                if (UnMHTSaveMulti.isSavable (targetDocument)) {
                    UnMHTSaveMulti.targetDocuments.push (targetDocument);
                }
            }
        }
        
        for (var j = 0; j < UnMHTSaveMulti.targetDocuments.length; j ++) {
            var targetDocument = UnMHTSaveMulti.targetDocuments [j];
                
            var title = targetDocument.title;
            if (title == "") {
                title = targetDocument.location.href;
            }
            
            listitem = document.createElement ("listitem");
            listcell = document.createElement ("listcell");
            listcell.setAttribute ("value", "save");
            listcell.setAttribute ("class", "listcell-iconic");
            listcell.setAttribute ("image",
                                   "chrome://unmht/content/check_o.png");
            listitem.appendChild (listcell);
            listcell = document.createElement ("listcell");
            listcell.setAttribute ("value", "");
            listcell.setAttribute ("label", title);
            listitem.addEventListener
                ("mousedown",
                 function () {
                    UnMHTSaveMulti.onMouseDownCheck (arguments [0]);
                }, false);
            listitem.appendChild (listcell);
            listbox.appendChild (listitem);
        }
    },
    
    /**
     * ファイル名を変更したイベント
     */
    changeFilename : function () {
        document.getElementById ("filename_base").disabled
        = document.getElementById ("filename_base_label").disabled
        = (document.getElementById ("filename").value != "sequential")
        && (document.getElementById ("saveformat").value != "single");
        
        if (document.getElementById ("saveformat").value == "single") {
            document.getElementById ("filename_base_label").value
                = document.getElementById ("filename_base_label_single").value;
        }
        else {
            document.getElementById ("filename_base_label").value
                = document.getElementById ("filename_base_label_seq").value;
        }
        
        window.sizeToContent ();
    },
    
    /**
     * 形式を変更したイベント
     */
    changeFormat : function () {
        document.getElementById ("filename").disabled
        = (document.getElementById ("saveformat").value != "separated");
        
        UnMHTSaveMulti.changeFilename ();
    },
    
    /**
     * 保存対象の項目を押したイベント
     *
     * @param  Event event
     *         対象のイベント
     */
    onMouseDownCheck : function (event) {
        var listitem = event.target;
        if (listitem.nodeName.toLowerCase () != "listitem") {
            return;
        }
        
        var listcell1 = listitem.firstChild;
        
        if (event.clientX
            < listcell1.boxObject.x + listcell1.boxObject.width) {
            var v = listcell1.getAttribute ("value");
            if (v == "save") {
                listcell1.setAttribute ("value", "ignore");
                listcell1.setAttribute ("image",
                                       "chrome://unmht/content/check_x.png");
            }
            else {
                listcell1.setAttribute ("value", "save");
                listcell1.setAttribute ("image",
                                       "chrome://unmht/content/check_o.png");
            }
        }
    },
    
    /**
     * ファイル、ディレクトリを選択する
     */
    selectBase : function () {
        var filePicker
        = Components.classes ["@mozilla.org/filepicker;1"]
        .createInstance (Components.interfaces.nsIFilePicker);
        var flag = Components.interfaces.nsIFilePicker.modeGetFolder;
        
        filePicker.init (window, "", flag);
        
        try {
            var base = document.getElementById ("base").value;
            
            var dir
                = Components.classes ["@mozilla.org/file/local;1"]
                .createInstance (Components.interfaces.nsILocalFile);
            dir.initWithPath (base);
            
            filePicker.displayDirectory = dir;
        }
        catch (e) {
        }
        
        if (filePicker.show ()
            == Components.interfaces.nsIFilePicker.returnOK) {
            document.getElementById ("base").value
            = filePicker.file
            .QueryInterface (Components.interfaces.nsILocalFile).path;
        }
    },
    
    /**
     * ラヂオボタンの選択肢を表示に反映する
     * (古いバージョンだと value の変更だけでは反映されない)
     *
     */
    selectItem : function (node) {
        var value = node.value;
        
        var nodes = node.getElementsByTagName ("radio");
        for (var i = 0; i < nodes.length; i ++) {
            if (nodes [i].value == value) {
                node.selectedItem = nodes [i];
            }
        }
    },
    
    /**
     * 保存可能かどうかを調べる
     *
     * @param  HTMLDocument targetDocument
     *         対象のドキュメント
     * @return Boolean
     *         保存可能かどうか
     */
    isSavable : function (targetDocument) {
        if ("__unmht_no_save_" in targetDocument) {
            return false;
        }
        else if (targetDocument.contentType.match (/^text/)
            || targetDocument.contentType.match (/\/x(ht)?ml$/)) {
            return true;
        }
        else {
            return false;
        }
    },
    
    /**
     * 保存する際のファイル名を取得する
     *
     * @param  HTMLDocument targetDocument
     *         対象のドキュメント
     */
    getFilename : function (targetDocument) {
        var filename;
        var title, uri;
        
        filename = "";
        
        uri = targetDocument.location.href;
        title = targetDocument.title;
        
        if (uri.match (/[^\?]+\/([^\/\?]+)(\?.+)?(#.+)?$/)) {
            filename = RegExp.$1;
            if (filename.match (/^(.+)\.[^\.]+$/)) {
                filename = RegExp.$1;
            }
            else {
                filename = filename;
            }
        }
        else {
            filename = "index";
        }
        
        if (document.getElementById ("filename").value == "title") {
            var tmp = UnMHTSaveMulti.validateFileName (title);
            
            if (tmp) {
                filename = tmp;
            }
        }
        else if (document.getElementById ("filename").value == "custom") {
            var pattern = UnMHTSaveMulti.saveFilenameCustom;
            var am = UnMHTSaveMulti.saveFilenameCustomAM;
            var pm = UnMHTSaveMulti.saveFilenameCustomPM;
            
            filename
            = UnMHTFormatter.format (pattern, title, filename, uri, am, pm);
        }
        else {
            filename = UnMHTFormatter.validateFileName (filename);
        }
        
        return filename;
    },
    
    /**
     * ファイル名に使えない文字を変換する
     *
     * @param  String filename
     *         元のファイル名
     * @return String
     *         変換したファイル名
     */
    validateFileName : function (filename) {
        var re = /[\/]+/g;
        if (navigator.appVersion.indexOf ("Windows") != -1) {
            re = /[\\\/\|]+/g;
            filename = filename.replace (/[\"]+/g, "'")
                .replace (/[\*\:\?]+/g, " ")
                .replace (/[\<]+/g, "(")
                .replace (/[\>]+/g, ")");
        }
        else if (navigator.appVersion.indexOf ("Macintosh") != -1) {
            re = /[\:\/]+/g;
        }
        
        filename = filename.replace (re, "_");
        
        return filename;
    }
};