/* -*- Mode: Java; tab-width: 4; indent-tabs-mode: nil; c-basic-offset: 4 -*- */

/* Opera/IE/Safari 版, QuickLook 版に移植する部分 (1) ---- ここから ---- */
/**
 * mht ファイルに含まれるファイル1つ当たりの情報
 */
function UnMHTExtractorFile () {
}
UnMHTExtractorFile.prototype = {
    charset : "",         /* String  Content-Type のうち、文字コード */
    filetype : "",        /* String  Content-Type のうち、MIME タイプ */
    
    cid : "",             /* String  Content-ID の値 */
    
    location : "",        /* String  ファイルのアドレス */
    contentLocation : "", /* String  Content-Location の値 */
    contentBase : "",     /* String  Content-Base の値 */
    
    baseElementDir : "",  /* String  base 要素の値 */
    
    baseDir : "",         /* String  親ディレクトリ */
    referredBaseDir : "", /* String  参照元のファイルの親ディレクトリ
                           *   IE で保存されたファイルの場合
                           *   CSS から CSS が相対パスで参照されると
                           *   パスがおかしくなるため、これを修正するために用いる */
    
    leafName : "",        /* String  ファイル名 */
    extension : "",       /* String  拡張子 (. も含む) */
    
    disposition : "",     /* String  Content-Disposition の filename の値 */
    dispositionType : "", /* String  Content-Disposition のタイプ */
    
    encoding : 0,         /* Number  Content-Encoding の値
                           *   1: quoted-printable
                           *   2: base64
                           *   3: 7bit
                           *   0: 8bit */
    
    content : "",         /* String  ファイルの中身 */
    originalContent : "", /* String  ファイルの元の中身 */
    
    deleted : false,      /* Boolean  展開しない事を示すフラグ */
    
    nativeFilename : "",  /* String  保存したファイル名 */
    size : 0,             /* Number  ファイルサイズ */
    
    refName : "",         /* String  参照用のファイル名 */
    
    headerMap : null,     /* Object  ヘッダ
                           *   <String フィールド名, String フィールド値> */
    headerList : null,    /* Array  ヘッダ (小文字化しない)
                           *   [[String フィールド名, String フィールド値], ...] */
    
    boundary : "",        /* String  boundary パラメータ */
    childFiles : null     /* Array  含むファイル (multipart の場合)
                           *   [UnMHTExtractorFile, ...] */
};

/*
 * ファイルの展開部分
 */
function UnMHTExtractor () {
}
UnMHTExtractor.prototype = {
    original : "",         /* String  展開したファイル名の URI */
    rootURI : "",          /* String  ルートドキュメントの URI */
    
    redirect : "",         /* String  最初のドキュメントを置き換える場合の参照名 */
    
    subject : "",          /* String  Subject の値 */
    date : "",             /* String  Date の値 */
    headerMap : null,      /* Object  ヘッダ
                            *   <String フィールド名, String フィールド値> */
    
    start : "",            /* String  ルートドキュメントの CID */
    
    rootFile : null,       /* UnMHTExtractorFile  ルートドキュメントのファイル */
    alternative : false,   /* Boolean  multipert/alternative に入ったか */
    files : null,          /* Array  mht ファイルの中にあるファイル
                            *   [UnMHTExtractorFile ファイル情報,
                            *    ...] */
    refFiles : null,       /* Object  参照できるファイル
                            *   <String 参照用のファイル名,
                            *    UnMHTExtractorFile ファイル情報> */
    
    firstFile : null,      /* UnMHTExtractorFile  MHT ファイルの直下のファイル */
    
    extractTime : 0,       /* Number  展開時刻 */
    extractName : "",      /* String  展開先のディレクトリの名前 */
    lastAccessTime : 0,    /* Number  最終アクセス時刻 */
    
    count : 0,             /* Number  展開したファイルの数 */
    size : 0,              /* Number  全キャッシュのサイズ */
    hasCache : false,      /* Boolean mht のキャッシュを持っているか */
    cacheFilename : "",    /* String  mht のキャッシュのファイル名 */
    cacheSize : 0,         /* Number  mht のキャッシュのサイズ */
    
    retcode : "",          /* String  mht ファイルの改行コード */
    headerRegExp : null,   /* RegExp  ヘッダを分割する正規表現 */
    valuesRegExp : null,   /* RegExp  ヘッダの値を分割する正規表現 */
    
    /**
     * mht ファイルを展開する
     *
     * @param  String originalURISpec
     *         展開したファイル名の URI 表記
     * @param  String text
     *         mht ファイルの内容
     * @param  Boolean utf16
     *         text が UTF-16 であるかどうか
     * @param  String extractName
     *         展開先のディレクトリ名
     *           一旦ダウンロードする場合には先に作られているので
     *           その値を渡す
     *           "" の場合は自動的に作られる
     * @param  Boolean extract
     *         展開するかどうか
     *           false の場合、text で与えられた内容のファイルを作る
     * @return String
     *         Firefox 版
     *           ルートドキュメントの URL
     *         Opera/Safari 版
     *           ファイルの data 形式の URI
     *           展開できなかった場合は ""
     */
    extractMHT : function (originalURISpec, text, utf16,
                           extractName, extract) {
        if (UnMHT.mode == 1) {
            this.original = originalURISpec
            .replace (/\(/g, "%28")
            .replace (/\)/g, "%29")
            .replace (/\'/g, "%27")
            .replace (/\"/g, "%22")
            .replace (/\[/g, "%5B")
            .replace (/\]/g, "%5D")
            .replace (/ /g, "%20");
            
            this.rootURI
            = UnMHT.protocolHandler.enUnMHTURI (this.original);
            
            this.original
            = UnMHT.protocolHandler.deUnMHTURI (this.rootURI);
            
            this.extractTime = (new Date ()).getTime ();
                
            /* UnMHT.enableNolimit を取得する */
            if (Components.interfaces.nsIPrefBranch2 == undefined) {
                /* 監視していない場合にのみ設定を取得する */
                UnMHTConfigManager.getConfigurationFromPreferences ();
            }
            
            if (UnMHT.enableNolimit) {
                /* 時間制限を解除する */
                var defaultTime = -1;
                try {
                    defaultTime
                        = UnMHTConfigManager.prefBranch
                        .getIntPref ("dom.max_script_run_time");
                    UnMHTConfigManager.prefBranch
                        .setIntPref ("dom.max_script_run_time", 0);
                }
                catch (e) {
                    defaultTime = -1;
                }
                var defaultTimeChrome = -1;
                try {
                    defaultTimeChrome
                        = UnMHTConfigManager.prefBranch
                        .getIntPref ("dom.max_chrome_script_run_time");
                    UnMHTConfigManager.prefBranch
                        .setIntPref ("dom.max_chrome_script_run_time", 0);
                }
                catch (e) {
                    defaultTimeChrome = -1;
                }
            }
            
            /* 一定時間以上経ったキャッシュを削除する */
            UnMHT.clearCache (UnMHT.cacheExpire, false);
            
            if (!UnMHT.enableMemoryCache) {
                var extractDirectory = "";
                if (extractName == "") {
                    /* 展開先のディレクトリを作る */
                    extractName = UnMHT.createExtractName ();
                    
                    extractDirectory
                        = UnMHTFileManager.cacheDirectory
                        + UnMHTFileManager.separator + extractName;
                    UnMHTFileManager.createDirectory (extractDirectory);
                }
                else {
                    extractDirectory
                        = UnMHTFileManager.cacheDirectory
                        + UnMHTFileManager.separator + extractName;
                }
                
                this.extractName = extractName;
            }
        }
        else if (UnMHT.mode == 2) {
            this.original = escape (originalURISpec);
            this.rootURI = this.original;
        }
        
        try {
            this.rootFile = null;
            this.alternative = false;
            
            if (extract) {
                /* 展開する */
                
                /* 改行コードのチェック */
                this.retcode = "";
                if (text.search (/(\r\n|\r|\n)/) != -1) {
                    this.retcode = RegExp.$1;
                    this.headerRegExp
                        = new RegExp ("([^:]+): *([^" + this.retcode + "]*"
                                      + this.retcode
                                      + "([\t ]+[^" + this.retcode + "]*"
                                      + this.retcode + ")*)",
                                      "g");
                    this.valuesRegExp
                        = new RegExp ("[\t ]*([^" + this.retcode + "]*)"
                                      + this.retcode,
                                      "g");
                }
                
                if (this.retcode) {
                    this.files = new Array ();
                    this.refFiles = new Object ();
                    
                    this.firstFile = this.parseMHT (text, utf16);
                }
            }
            
            if (this.rootFile != null) {
                /* 解析に成功した場合 */
                
                /* 空のファイルを削除する */
                this.deleteEmptyFile ();
                
                /* 参照名を重複しないように設定する */
                this.setRefName ();
                
                if (UnMHT.enableFilter) {
                    /* フィルタをかける設定の場合 */
                    this.applyFilter ();
                }
                
                /* 内容をデコードする */
                this.decodeContent (utf16);
                
                /* file プロトコル、cid プロトコルを置き換える */
                this.replaceProtocol ();
                
                if (UnMHT.mode == 1) {
                    if (!UnMHT.enableFastExtract) {
                        /* CSS 中の URI を置き換える */
                        this.replaceCSSLocation ();
                    }
                    
                    /* 後で置き換えられない要素の URI を置き換える */
                    this.replaceLocationMode1 ();
                }
                else if (UnMHT.mode == 2) {
                    /* URI を置き換える */
                    this.replaceLocationMode2 ();
                    
                    /* 文字コードを変換する */
                    var charset = "";
                    if (text.search (new RegExp ("[\u0100-\uffff]")) != -1) {
                        text = UnMHTConverter.btoa16 (this.rootFile.content);
                        charset = "charset=utf-16;";
                    }
                    else {
                        text = UnMHTConverter.btoa8 (this.rootFile.content);
                        if (this.rootFile.charset) {
                            charset = "charset=" + this.rootFile.charset + ";";
                        }
                    }
                    
                    return "data:text/html;"
                    + charset
                    + "unmht=" + this.rootURI + ";"
                    + "base64," + text;
                }
            }
            else {
                /* 解析に失敗した場合、もしくは展開しなかった場合 */
                if (UnMHT.mode == 1) {
                    var file = new UnMHTExtractorFile ();
                    
                    if (extract) {
                        /* 展開するはずならば、中身が HTML のファイルとみなす */
                        file.extension = ".html";
                        file.refName = "index.html";
                        file.filetype = "text/html";
                    }
                    else {
                        /* mht のソースを出力する */
                        file.extension = ".txt";
                        file.refName = "index.txt";
                        file.filetype = "text/plain";
                    }
                    
                    if (utf16) {
                        text
                        = UnMHTConverter.convertFromUnicode (text,
                                                             "shift_jis");
                    }
                    
                    this.rootFile = file;
                    file.location = originalURISpec;
                    file.cid = "";
                    file.encoding = 0;
                    file.charset = "shift_jis";
                    file.content = text;
                    this.splitLocation (file);
                    
                    this.files = new Array ();
                    this.refFiles = new Object ();
                    this.files.push (file);
                    
                    this.firstFile = file;
                }
                else {
                    return "";
                }
            }
            
            /* ファイルを作成する */
            this.createFile (extractDirectory);
        }
        catch (e) {
            throw e;
        }
        
        if (UnMHT.enableNolimit) {
            /* 時間制限を元に戻す */
            try {
                if (defaultTime != -1) {
                    UnMHTConfigManager.prefBranch
                    .setIntPref ("dom.max_script_run_time", defaultTime);
                }
            }
            catch (e) {
            }
            try {
                if (defaultTime != -1) {
                    UnMHTConfigManager.prefBranch
                    .setIntPref ("dom.max_chrome_script_run_time",
                                 defaultTimeChrome);
                }
            }
            catch (e) {
            }
        }
        
        this.lastAccessTime = (new Date ()).getTime ();
        
        return this.rootURI + this.redirect;
    },
    
    /**
     * mht ファイルを解析する
     *
     * @param  String text
     *         mht ファイルの内容
     * @param  Boolean utf16
     *         text が UTF-16 であるかどうか
     * @return UnMHTExtractorFile
     *         直下のファイル
     */
    parseMHT : function (text, utf16) {
        var start_pos, end_pos;
        
        start_pos = 0;
        
        /* ヘッダの終わりの検索 */
        end_pos = text.indexOf (this.retcode + this.retcode, start_pos);
        if (end_pos == -1) {
            /* ヘッダが存在しない */
            return null;
        }
        
        var header = text.substr (start_pos,
                                  end_pos + this.retcode.length - start_pos);
        var body = text.substr (end_pos + this.retcode.length * 2);
        
        var extractor = this;
        /* ヘッダを解析するだけなので代入はしない */
        var headerMap = new Object ();
        var headerList = new Array ();
        header.replace
        (this.headerRegExp,
         function (matched, name, tmp) {
            var value = "";
            /* 値を解析するだけなので代入はしない */
            tmp.replace
                (extractor.valuesRegExp,
                 function (matched, part1) {
                    value += UnMHTConverter.decode_ew (part1, utf16);
                    
                    return "";
                });
            headerMap [name.toLowerCase ()] = value;
            headerList.push ([name, value]);
            
            return "";
        });
        
        var file = this.parseHeader (headerMap, headerList);
        if (file == null) {
            /* ヘッダが異常な場合、終了する */
            return null;
        }
        if (file.filetype.match (/^multipart\//i)) {
            /* multipart の場合 */
            if (file.filetype.match (/^multipart\/alternative/i)) {
                this.alternative = true;
            }
            var b = file.boundary
            .replace (/(\\\[\]\(\)\^\,\.\{\}\|\?\!\-\*\+\$)/, "\\$1");
            var boundaryRegExp = new RegExp ("--"
                                             + b
                                             + "(--)?(" + this.retcode + ")?");
            var bodies = body.split (boundaryRegExp);
            file.childFiles = new Array ();
            for (var i = 1; i < bodies.length - 1; i ++) {
                /* 最初と最後は boundary に挟まれていないので無効 */
                if (bodies [i]) {
                    var file2 = this.parseMHT (bodies [i], utf16);
                    if (file2) {
                        file.childFiles.push (file2);
                    }
                }
            }
            this.alternative = false;
            
            return file;
        }
        
        if (file.encoding == 1) {
            /* quoted-printable */
            file.content
            = body.replace (new RegExp ("=" + this.retcode, "g"), "");
        }
        else if (file.encoding == 2) {
            /* base64 */
            file.content
            = body.replace (new RegExp (this.retcode, "g"), "");
        }
        else {
            file.content = body;
        }
        if (file.filetype == "application/octet-stream") {
            /* CGI の応答等の HTML かもしれない */
            var tmp;
            if (file.content.length > 32) {
                tmp = file.content.substr (0, 32);
            }
            else {
                tmp = file.content;
            }
            if (tmp.search (/</) != -1) {
                /* 先頭がタグっぽい */
                if (file.content.search (/<html/i) != -1) {
                    file.filetype = "text/html";
                }
            }
        }
        
        return file;
    },
    
    /**
     * ヘッダを解析して UnMHTExtractorFile オブジェクトを作成する
     *
     * @param  Object headerMap
     *         ヘッダ
     *           <String フィールド名, String フィールド値>
     * @param  Array headerList
     *         ヘッダ (小文字化しない)
     *           [[String フィールド名, String フィールド値], ...]
     * @return UnMHTEnxtractorFile
     *         作成されたファイル情報
     */
    parseHeader : function (headerMap, headerList) {
        var i;
        var name, value, valueMap;
        var value2Lower;
        var file;
        var boundary = "";
        
        file = new UnMHTExtractorFile ();
        
        file.charset = "";
        file.headerMap = headerMap;
        file.headerList = headerList;
        
        /* Content-Type を解析 */
        if ("content-type" in file.headerMap) {
            value
                = UnMHTConverter
                .convertFromUnicode (file.headerMap ["content-type"],
                                     "shift_jis");
        }
        else {
            value = "text/html";
        }
        valueMap = this.parseValue (value, true);
        for (name in valueMap) {
            if (name == "_") {
                file.filetype = valueMap [name];
            }
            if (name == "charset") {
                file.charset = valueMap [name];
            }
            else if (name == "boundary") {
                boundary = valueMap [name];
            }
            else if (name == "start") {
                this.start
                    = valueMap [name].replace (/^</, "").replace (/>$/, "");
            }
        }
        
        /* Subject を解析 */
        if ("subject" in file.headerMap) {
            this.subject = file.headerMap ["subject"];
        }
        
        /* Date を解析 */
        if ("date" in file.headerMap) {
            this.date = file.headerMap ["date"];
        }
        
        if (file.filetype != "") {
            if (file.filetype.match (/^multipart\//i)) {
                /* マルチパート */
                if (boundary) {
                    file.boundary = boundary;
                }
                else {
                    /* ヘッダが異常 */
                    return null;
                }
            }
            else {
                /* 通常のファイルならば */
                
                /* Content-Disposition を解析 */
                file.disposition = "";
                if ("content-disposition" in file.headerMap) {
                    var disposition = file.headerMap ["content-disposition"];
                    if (disposition != undefined
                        && disposition.toLowerCase ()
                        != "inline") {
                        
                        valueMap
                            = this.parseValue (disposition,
                                               false);
                        
                        for (name in valueMap) {
                            if (name == "_") {
                                file.dispositionType = valueMap [name];
                            }
                            else if (name == "filename") {
                                file.disposition = valueMap [name];
                            }
                        }
                    }
                }
        
                /* Content-Base を解析 */
                if ("content-base" in file.headerMap) {
                    file.contentBase = file.headerMap ["content-base"];
                }
                else {
                    file.contentBase = undefined;
                }
                if ("content-location" in file.headerMap) {
                    file.contentLocation = file.headerMap ["content-location"];
                }
                else {
                    file.contentLocation = undefined;
                }
                if (file.contentBase) {
                    if (file.contentLocation) {
                        file.location
                        = UnMHTFileManager.jointPath
                        (file.contentBase, file.location)
                    }
                    else {
                        file.location = file.contentBase;
                    }
                }
                else {
                    file.location = file.contentLocation;
                }
                
                if (file.location == undefined) {
                    /* ルートドキュメントの Content-Location が
                     * 指定されない場合があるので index.html とする */
                    file.location = "";
                    if (file.filetype == "text/html") {
                        file.location = "index.html";
                    }
                }
                if (UnMHT.mode == 1) {
                    file.location
                    = file.location.replace
                    (/^(file:\/\/(\/\/)?(\/)?)/,
                     function (matched, uri) {
                        return "unmht:///dummy.0/";
                    });
                }
                else if (UnMHT.mode == 2) {
                    file.location
                    = file.location.replace (/^file:\/\/(\/\/)?(\/)?/,
                                             "data:text/plain,dummy:");
                }
                
                this.splitLocation (file);
                
                /* Content-ID を解析 */
                if ("content-id" in file.headerMap) {
                    file.cid = file.headerMap ["content-id"];
                    if (file.cid) {
                        file.cid = file.cid.replace (/^<([^>]+)>$/, "$1");
                    }
                }
                else {
                    file.cid = "";
                }
                
                /* ファイル名を調べる */
                var leafName = "";
                if (file.disposition == "") {
                    /* Content-Disposition が存在しない場合 */
                    
                    leafName = file.leafName;
                }
                else {
                    /* Content-Disposition が存在する場合 */
                    
                    leafName = file.disposition;
                }
                
                if (leafName.match (/(\.[A-Za-z0-9]+)$/)) {
                    /* ファイル名に拡張子が付いている場合はそれを付ける */
                    file.extension = RegExp.$1;
                }
                else {
                    file.extension = "";
                }
                
                file.referredBaseDir = "";
                
                /* Content-Transfer-Encoding を解析する */
                if ("content-transfer-encoding" in file.headerMap) {
                    value = file.headerMap ["content-transfer-encoding"];
                    value
                        = UnMHTConverter.convertFromUnicode (value,
                                                             "shift_jis");
                }
                else {
                    value = "";
                }
                var value2Lower = value.toLowerCase ();
                if (value2Lower == "quoted-printable") {
                    file.encoding = 1;
                }
                else if (value2Lower == "base64") {
                    file.encoding = 2;
                }
                else if (value2Lower == "7bit") {
                    file.encoding = 3;
                }
                else {
                    file.encoding = 0;
                }
                
                if (file.filetype == "text/html") {
                    if ((this.rootFile == null
                         || this.alternative)
                        || (this.start && this.start == file.cid)) {
                        /* 最初の HTML ファイルか、指定された Content-ID ならば、
                         * これをルートドキュメントとする */
                        this.rootFile = file;
                        this.alternative = false;
                    }
                }
                
                this.files.push (file);
            }
        }
        
        return file;
    },
    
    /**
     * Content-Type/Content-Disposition の値を解析する
     *
     * @param  String value
     *         Content-Type/Content-Disposition の値
     * @param  Boolean mimeType
     *         値のみのフィールドは MIME Type か
     * @return Object
     *         解析した値のマップ
     *           <String 名前, String 値>
     */
    parseValue : function (value, mimeType) {
        var parts;
        var i;
        var map;
        var name;
        var tmp;
        var realName, realValue;
        
        map = new Object ();
        
        /* 値を解析するだけなので代入はしない */
        value.replace
        (/[^ \t;]+/g,
         function (matched) {
            if (matched.match (/^([^=]*)=(.*)$/)) {
                name = RegExp.$1.toLowerCase ();
                value = RegExp.$2;
                if (value.match (/^[\"\'](.*)[\"\']$/)) {
                    value = RegExp.$1;
                }
                map [name] = value;
            }
            else if ((matched.indexOf ("/") != -1
                      || !mimeType)
                     && matched.indexOf ("=") == -1) {
                map ["_"] = matched;
            }
            return "";
        });
        
        for (var name in map) {
            if (name.match (/^([^\*]+)\*(([0-9]+))?\*?$/)) {
                /* RFC2231 */
                
                realName = RegExp.$1;
                if (RegExp.$2) {
                    /* 複数の値 */
                    if (RegExp.$3 == "0") {
                        /* 最初の値 */
                        
                        realValue = "";
                        i = 0;
                        for (;;) {
                            if ((realName + "*" + i + "*") in map) {
                                /* エンコードあり */
                                tmp = map [realName + "*" + i + "*"];
                                if (tmp.match (/^([^\']+)\'([^\']+)?\'(.+)$/)) {
                                    try {
                                        tmp
                                            = UnMHTConverter .convertToUnicode
                                            (unescape (RegExp.$3), RegExp.$1);
                                    }
                                    catch (e) {
                                        tmp = unescape (RegExp.$3);
                                    }
                                }
                                realValue += tmp;
                            }
                            else if ((realName + "*" + i) in map) {
                                /* エンコードなし */
                                realValue += map [realName + "*" + i];
                            }
                            else {
                                break;
                            }
                            i ++;
                        }
                    }
                    else {
                        continue;
                    }
                }
                else {
                    /* 単体でエンコードあり */
                    tmp = map [name];
                    if (tmp.match (/^([^\']+)\'([^\']+)?\'(.+)$/)) {
                        try {
                            tmp
                                = UnMHTConverter.convertToUnicode
                                (unescape (RegExp.$3), RegExp.$1);
                        }
                        catch (e) {
                            tmp = unescape (RegExp.$3);
                        }
                    }
                    realValue = tmp;
                }
                
                map [realName] = realValue;
            }
        }
        
        return map;
    },
    
    /**
     * 空のファイルを削除する
     */
    deleteEmptyFile : function () {
        var file;
        
        for (i = 0; i < this.files.length; i ++) {
            file = this.files [i];
            if (file.content == "") {
                this.files.splice (i, 1);
                i --;
            }
        }
    },
    
    /**
     * 参照名を重複しないように設定する
     */
    setRefName : function () {
        var refName, refBase;
        var i, j, suffix;
        var file, file2;
        
        for (i = 0; i < this.files.length; i ++) {
            file = this.files [i];
            
            var leafName = file.leafName;
            var p = leafName.indexOf ("?");
            if (p != -1) {
                leafName = leafName.substr (0, p);
            }
            if (leafName) {
                if (leafName.match (/([^\/\\:\!]+)(\.[A-Za-z0-9]+)$/)) {
                    refBase = RegExp.$1;
                }
                else {
                    refBase = file.leafName;
                }
            }
            else if (file.cid) {
                refBase = file.cid;
            }
            else if (file.filetype == "text/html") {
                refBase = "index";
            }
            else {
                refBase = i;
            }
            refBase = escape (refBase).replace (/\//g, "_");
            
            suffix = 0;
            file.refName = "";
            while (file.refName == "") {
                if (suffix == 0) {
                    refName = refBase + file.extension;
                }
                else {
                    refName = refBase + "." + suffix + file.extension;
                }
                
                for (j = 0; j < i; j ++) {
                    file2 = this.files [j];
                    
                    if (refName == file2.refName) {
                        break;
                    }
                }
                if (j == i) {
                    file.refName = refName;
                }
                suffix ++;
            }
        }
    },
    
    /**
     *  フィルタをかける
     */
    applyFilter : function () {
        var uri
        = Components.classes ["@mozilla.org/network/standard-url;1"]
        .createInstance (Components.interfaces.nsIURI);
            
        for (i = 0; i < this.files.length; i ++) {
            file = this.files [i];
            
            if (file.deleted) {
                continue;
            }
            
            for (var j = 0; j < UnMHT.filterList.length; j ++) {
                var text = "";
                if (UnMHT.filterList [j][0] == "host") {
                    try {
                        uri.spec = file.location;
                        
                        text = uri.host;
                    }
                    catch (e) {
                        text = "";
                    }
                }
                else if (UnMHT.filterList [j][0] == "leafname") {
                    text = file.leafName;
                }
                else if (UnMHT.filterList [j][0] == "extension") {
                    text = file.extension;
                }
                else if (UnMHT.filterList [j][0] == "location") {
                    text = file.location;
                }
                else if (UnMHT.filterList [j][0] == "mimetype") {
                    text = file.filetype;
                }
                
                var pos = -1;
                if (UnMHT.filterList [j][2]) {
                    pos = text.search (UnMHT.filterList [j][1]);
                }
                else {
                    pos = text.indexOf (UnMHT.filterList [j][1]);
                }
                
                if (pos != -1) {
                    /* フィルタに引っかかった場合、展開しない設定にする */
                    file.deleted = true;
                    file.extension = "";
                    file.encoding = 0;
                    file.content = "";
                    break;
                }
            }
        }
    },
    
    /**
     * 内容をデコードする
     *
     * @param  Boolean utf16
     *         text が UTF-16 であるかどうか
     */
    decodeContent : function (utf16) {
        var i;
        var file;
        
        for (i = 0; i < this.files.length; i ++) {
            file = this.files [i];
            
            if (file.deleted) {
                continue;
            }
            
            if (file.encoding == 1) {
                file.content
                    = file.content.replace
                    (/=([A-Fa-f0-9][A-Fa-f0-9])/g,
                     function (dummy, matched) {
                        return String.fromCharCode ("0x" + matched);
                    });
            }
            else if (file.encoding == 2) {
                if (UnMHT.mode == 1) {
                    file.content = atob (file.content);
                }
                else if (UnMHT.mode == 2) {
                    if (file == this.rootFile) {
                        file.content = UnMHTConverter.atob (file.content);
                    }
                }
            }
            else if (utf16) {
                if (file.filetype == "text/html"
                    && file.charset) {
                    file.content
                        = UnMHTConverter
                        .convertFromUnicode (file.content, file.charset);
                }
            }
            file.originalContent = file.content;
        }
    },
    
    /**
     * file プロトコル、cid プロトコルを置き換える
     */
    replaceProtocol : function () {
        var i;
        var file;
        
        for (i = 0; i < this.files.length; i ++) {
            file = this.files [i];
            
            if (file.deleted) {
                continue;
            }
            
            if (file.filetype == "text/css") {
                /* CSS ファイルの場合、アドレスのみでチェックする */
                if (UnMHT.mode == 1) {
                    file.content
                        = file.content
                        .replace
                        (/^(file:\/\/(\/\/)?(\/)?)/,
                         function (matched, uri) {
                            return UnMHT.protocolHandler.enUnMHTURI (uri);
                        })
                        .replace
                        (/(cid:)/ig,
                         function (matched, uri) {
                            return UnMHT.protocolHandler.enUnMHTURI (uri);
                        });
                }
                else if (UnMHT.mode == 2) {
                    file.content
                        = file.content
                        .replace
                        (/file:\/\/(\/\/)?(\/)?/ig,
                         "data:text/plain,dummy:")
                        .replace
                        (/cid:/ig,
                         "data:text/plain,cid:");
                }
            }
            else if (file.filetype.substr (0, 6) != "image/") {
                /* HTML ファイルの場合、属性でチェックする */
                if (UnMHT.mode == 1) {
                    file.content
                        = file.content
                        .replace
                        (/(<[^>]*)(src|href)([ \r\n\t]*=[ \r\n\t]*[\"\']?)(file:\/\/(\/\/)?(\/)?)/ig,
                         function (matched, tag, attr, prev, uri) {
                            uri = "unmht:///dummy.0/";
                            return tag + attr + prev + uri;
                        })
                        .replace
                        (/(<[^>]*)(src|href)([ \r\n\t]*=[ \r\n\t]*[\"\']?)(cid:)/ig,
                         function (matched, tag, attr, prev, uri) {
                            uri = UnMHT.protocolHandler.enUnMHTURI (uri);
                            return tag + attr + prev + uri;
                        });
                }
                else if (UnMHT.mode == 2) {
                    file.content
                        = file.content
                        .replace
                        (/(<[^>]*)(src|href)([ \r\n\t]*=[ \r\n\t]*[\"\']?)(file:\/\/(\/\/)?(\/)?)/ig,
                         "$1$2$3data:text/plain,dummy:")
                        .replace
                        (/(<[^>]*)(src|href)([ \r\n\t]*=[ \r\n\t]*[\"\']?)(cid:)/ig,
                         "$1$2$3data:text/plain,cid:");
                }
            }
        }
    },
    
    checkReferRe : /(<link[ \r\n\t][^>]*href[ \r\n\t]*=[ \r\n\t]*[\"\']?)([^\"\' >]*)([\"\']?[ \r\n\r]*)/ig,
    /**
     * HTML から CSS への参照をチェックする
     *
     * @param  UnMHTExtractorFile file
     *         対象のファイル
     * @param  String matched
     *         マッチした全体
     *           prev + path + next
     * @param  String prev
     * @param  String path
     * @param  String next
     *         以下参照
     *                              path
     *                              ---------
     * <link rel="stylesheet" href="12345.css"  />
     * -----------------------------         --
     * prev                                  next
     */
    checkReferFunc : function (file,
                               matched, prev, path, next) {
        var list
        = UnMHT.checkFile (this, file, path, false);
        
        if (list [0] != -1
            && list [1]) {
            /* 含まれており展開した場合、参照関係を設定する */
            list [1].referredBaseDir = file.baseDir;
        }
    },
    
    styleElementRe : /([^a-zA-Z0-9_]url[ \r\n\t]*\([ \r\n\t]*[\"\']?)([^\)\"\' ]*)([\"\']?[ \r\n\r]*\))/ig,
    /**
     * Style 要素内の CSS を変換する
     *
     * @param  UnMHTExtractorFile file
     *         対象のファイル
     * @param  String matched
     *         マッチした全体
     *           prev + path + next
     * @param  String prev
     * @param  String path
     * @param  String next
     *         以下参照
     *                          path
     *                          ---------
     * background-image: :url ("12345.jpg");
     *                   ---=---         --
     *                   prev            next
     * @return String
     *         変換した結果
     */
    styleElementFunc : function (file,
                                 matched, prev, path, next) {
        var list
        = UnMHT.checkFile (this, file, path, false);
        
        if (list [0] != -1) {
            /* 含まれていた場合 */
            if (list [1]) {
                /* 展開した場合、参照関係を設定してパスを置き換える */
                list [1].referredBaseDir = file.baseDir;
                if (UnMHT.mode == 1) {
                    return prev + this.rootURI + list [1].refName + next;
                }
            }
            else {
                /* 展開しなかった場合、削除する */
                return prev + next;
            }
        }
        /* 含まれていない場合 */
        
        if (UnMHT.protocolHandler.isUnMHTURI (path)) {
            var param = UnMHT.protocolHandler.getUnMHTURIParam (path);
            if (param.protocol == "dummy") {
                /* 参照先はローカルファイルの場合、削除する */
                return prev + next;
            }
        }
        
        if (path.match (/^[A-Za-z0-9\-]+:/)) {
            /* 絶対パスの場合そのままにする */
            return matched;
        }
        
        if (file.baseDir == "") {
            /* 元のアドレスが不明な場合、削除する */
            return prev + next;
        }
        
        /* 相対パスの場合、元の場所へ取りに行くようにする */
        return prev
        + UnMHTFileManager.jointPath (file.baseDir, path)
        + next;
    },
    
    styleElementRe2 : /(@import[ \t\r\n]*\(?[ \t\r\n]*[\"\']?)([^\"\'\)]+)([\"\']?[ \t\r\n]*\)?[ \t\r\n]*;?)/ig,
    /**
     * Style 要素内の CSS を変換する
     *
     * @param  UnMHTExtractorFile file
     *         対象のファイル
     * @param  String matched
     *         マッチした全体
     *           prev + path + next
     * @param  String prev
     * @param  String path
     * @param  String next
     *         以下参照
     *                            path
     *                            ---------
     * background-image: @import "12345.jpg";
     *                   ---------         --
     *                   prev              next
     * @return String
     *         変換した結果
     */
    styleElementFunc2 : function (file,
                                  matched, prev, path, next) {
        if (path.match (/^url/)) {
            return matched;
        }
        var list
        = UnMHT.checkFile (this, file, path, false);
        
        if (list [0] != -1) {
            /* 含まれていた場合 */
            if (list [1]) {
                /* 展開した場合、参照関係を設定してパスを置き換える */
                list [1].referredBaseDir = file.baseDir;
                if (UnMHT.mode == 1) {
                    return prev + this.rootURI + list [1].refName + next;
                }
            }
            else {
                /* 展開しなかった場合、削除する */
                return prev + next;
            }
        }
        /* 含まれていない場合 */
        
        if (UnMHT.protocolHandler.isUnMHTURI (path)) {
            var param = UnMHT.protocolHandler.getUnMHTURIParam (path);
            if (param.protocol == "dummy") {
                /* 参照先はローカルファイルの場合、削除する */
                return prev + next;
            }
        }
                            
        if (path.match (/^[A-Za-z0-9\-]+:/)) {
            /* 絶対パスの場合そのままにする */
            return matched;
        }
        
        if (file.baseDir == "") {
            /* 元のアドレスが不明な場合、削除する */
            return prev + next;
        }
        
        /* 相対パスの場合、元の場所へ取りに行くようにする */
        return prev
        + UnMHTFileManager.jointPath (file.baseDir, path)
        + next;
    },
    
    cssFileRe : /([^a-zA-Z0-9_]url[ \r\n\t]*\([ \r\n\t]*[\"\']?)([^\)\"\' ]*)([\"\']?[ \r\n\r]*\))/ig,
    /**
     * Style 要素内の CSS を変換する
     *
     * @param  UnMHTExtractorFile file
     *         対象のファイル
     * @param  String matched
     *         マッチした全体
     *           prev + path + next
     * @param  String prev
     * @param  String path
     * @param  String next
     *         以下参照
     *                          path
     *                          ---------
     * background-image: :url ("12345.jpg");
     *                   -------         --
     *                   prev            next
     * @return String
     *         変換した結果
     */
    cssFileFunc : function (file,
                                 matched, prev, path, next) {
        var list
        = UnMHT.checkFile (this, file, path, true);
        
        if (list [0] != -1) {
            /* 含まれていた場合 */
            if (list [1]) {
                /* 展開した場合、参照関係を設定してパスを置き換える */
                list [1].referredBaseDir = file.baseDir;
                if (UnMHT.mode == 1) {
                    return prev + this.rootURI + list [1].refName + next;
                }
            }
            else {
                /* 展開しなかった場合、削除する */
                return prev + next;
            }
        }
        /* 含まれていない場合 */
        
        if (UnMHT.protocolHandler.isUnMHTURI (path)) {
            var param = UnMHT.protocolHandler.getUnMHTURIParam (path);
            if (param.protocol == "dummy") {
                /* 参照先はローカルファイルの場合、削除する */
                return prev + next;
            }
        }
                            
        if (path.match (/^[A-Za-z0-9\-]+:/)) {
            /* 絶対パスの場合そのままにする */
            return matched;
        }
        
        if (file.baseDir == "") {
            /* 元のアドレスが不明な場合、削除する */
            return prev + next;
        }
        
        /* 相対パスの場合、元の場所へ取りに行くようにする */
        return prev
        + UnMHTFileManager.jointPath (file.baseDir, path)
        + next;
    },
    
    /**
     * CSS 中の URI を置き換える
     */
    replaceCSSLocation : function () {
        var i;
        var file;
        
        var extractor = this; /* 関数内で使用するための this の代わり */
        
        for (i = 0; i < this.files.length; i ++) {
            file = this.files [i];
                
            if (file.deleted) {
                continue;
            }
            
            if (file.filetype.substr (0, 6) != "image/"
                && file.filetype != "text/css") {
                
                /* チェックするだけなので代入しない */
                file.content
                    .replace (this.checkReferRe,
                              function (matched, prev, path, next) {
                                  extractor.checkReferFunc
                                      (file,
                                       matched, prev, path, next);
                                  return "";
                              });
                
                file.content
                    = file.content
                    .replace (this.styleElementRe,
                              function (matched, prev, path, next) {
                                  return extractor.styleElementFunc
                                  (file,
                                   matched, prev, path, next);
                              });
                file.content
                    = file.content
                    .replace (this.styleElementRe2,
                              function (matched, prev, path, next) {
                                  return extractor.styleElementFunc2
                                  (file,
                                   matched, prev, path, next);
                              });
            }
        }
            
        for (i = 0; i < this.files.length; i ++) {
            file = this.files [i];
                
            if (file.deleted) {
                continue;
            }
            
            if (file.filetype == "text/css") {
                file.content
                = file.content
                .replace (this.cssFileRe,
                          function (matched, prev, path, next) {
                              return extractor.cssFileFunc
                              (file,
                               matched, prev, path, next);
                          });
                file.content
                    = file.content
                    .replace (this.styleElementRe2,
                              function (matched, prev, path, next) {
                                  return extractor.styleElementFunc2
                                  (file,
                                   matched, prev, path, next);
                              });
            }
        }
    },
    
    elementReMode1 : /(<(link|script|body|table|tr|td|th|base|img|link)[ \r\n\t]*[^>]*(src|href|background)[ \r\n\t]*=[ \r\n\t]*[\"\']?)([^\"\' >]*)([\"\']?[ \r\n\r]*)/ig,
    elementReMode2 : /(<(img|a|link)[ \r\n\t]*[^>]*(src|href)[ \r\n\t]*=[ \r\n\t]*[\"\']?)([^\"\' >]*)([\"\']?[ \r\n\r]*)/ig,
    
    /**
     * HTML から各ファイルへの参照を変換する
     *
     * @param  UnMHTExtractorFile file
     *         対象のファイル
     * @param  String matched
     *         マッチした全体
     *           prev + path + next
     * @param  String prev
     * @param  String name
     * @param  String attr
     * @param  String path
     * @param  String next
     *         以下参照
     *  name            attr   path
     *  ---             ---  ---------
     * <img width="100" src="12345.png"  />
     * ----------------------         --
     * prev                           next
     */
    elementFunc : function (file,
                            matched, prev, name, attr, path, next) {
        var list
        = UnMHT.checkFile (this, file, path, false);
        
        if (name.match (/base/i)) {
            if (file.baseElementDir) {
                file.baseElementDir
                    = UnMHTFileManager.jointPath (file.baseElementDir, path)
            }
            else if (file.baseDir) {
                file.baseElementDir
                    = UnMHTFileManager.jointPath (file.baseDir, path);
            }
            else {
                file.baseElementDir = path;
            }
        }
        
        if (list [0] != -1) {
            /* 含まれていた場合 */
            if (list [1]) {
                if (UnMHT.mode == 1) {
                    return prev + this.rootURI + list [1].refName
                        + list [2] + next;
                }
                else if (UnMHT.mode == 2) {
                    return prev
                        + "data:" + list [1].filetype + ";"
                        + "unmht=" + this.rootURI + list [1].refName + ";"
                        + "base64,"
                        + list [1].content + next;
                }
            }
            else {
                /* 展開しなかった場合、削除する */
                return prev + next;
            }
        }
        /* 含まれていない場合 */
        
        if (path.match (/^file:\/\/\/?/)) {
            /* 参照先はローカルファイルの場合、削除する */
            return prev + next;
        }
                            
        if (path.match (/^[A-Za-z0-9\-]+:/)) {
            /* 絶対パスの場合そのままにする */
            return matched;
        }
        
        if (file.baseDir == "") {
            /* 元のアドレスが不明な場合、削除する */
            return prev + next;
        }
        
        /* 相対パスの場合、元の場所へ取りに行くようにする */
        return prev
        + UnMHTFileManager.jointPath (file.baseDir, path)
        + next;
    },
    
    /**
     * URI を置き換える
     */
    replaceLocationMode1 : function () {
        var extractor = this; /* 関数内で使用するための this の代わり */
        
        var isPPT = false;
        var isExistsFrame = false;
        
        for (i = 0; i < this.files.length; i ++) {
            file = this.files [i];
            
            if (file.deleted) {
                continue;
            }
            
            if (file.filetype != "text/css"
                && file.filetype.substr (0, 6) != "image/") {
                if (file.refName == "frame.htm") {
                    isExistsFrame = true;
                }
                
                file.content
                    = file.content
                    .replace (this.elementReMode1,
                              function (matched, prev, name, attr, path, next) {
                                  return extractor.elementFunc
                                  (file,
                                   matched, prev, name, attr, path, next);
                              });
                if (file.content.indexOf
                    ("xmlns:v=\"urn:schemas-microsoft-com:vml\"") != -1) {
                    file.content
                        = file.content
                        .replace (/<(o|p|oa|v):[^>]+>/g, "");
                    isPPT = true;
                }
            }
        }
        
        if (isPPT && UnMHT.enableSkipPPTWarning && isExistsFrame) {
            this.redirect = "frame.htm";
        }
    },
    
    /**
     * URI を置き換える
     */
    replaceLocationMode2 : function () {
        var extractor = this; /* 関数内で使用するための this の代わり */
        
        this.rootFile.content
        = this.rootFile.content
        .replace (this.elementReMode2,
                  function (matched, prev, name, attr, path, next) {
                      return extractor.elementFunc
                      (file,
                       matched, prev, name, attr, path, next);
                  });
    },
    
    /**
     * 完了
     *
     * @param  String extractDirectory
     *         展開先のディレクトリ
     */
    createFile : function (extractDirectory) {
        var i;
        var file;
        
        for (i = 0; i < this.files.length; i ++) {
            file = this.files [i];
            
            if (file.deleted) {
                continue;
            }
            
            file.size = file.content.length
            if (!UnMHT.enableMemoryCache) {
                file.nativeFilename
                    = extractDirectory + UnMHTFileManager.separator + i;
                
                UnMHTFileManager.createFile (file.nativeFilename,
                                             file.content);
            }
            
            this.refFiles [file.refName] = file;
            
            this.count ++;
            this.size += file.content.length;
        }
        
        if (!UnMHT.enableMemoryCache) {
            var cacheFile;
            
            var filename
            = UnMHTFileManager.cacheDirectory
            + UnMHTFileManager.separator + this.extractName
            + UnMHTFileManager.separator + "cache";
            cacheFile = UnMHTFileManager.initFile (filename);
            if (cacheFile.exists ()) {
                this.hasCache = true;
                this.cacheFilename = filename;
                this.cacheSize = cacheFile.fileSize;
                
                this.size += this.cacheSize;
            }
        }
    },
    
    /**
     * ファイルのアドレスを親ディレクトリとファイル名に分割する
     *
     * @param  UnMHTExtractorFile file
     *         対象のファイル情報
     */
    splitLocation : function (file) {
        var leafNameRe = null;
        
        var location = file.location;
        var postfix = "";
        
        var p = location.indexOf ("?");
        if (p != -1) {
            postfix = location.substr (p);
            location = location.substr (0, p);
        }
        
        if (location.indexOf ("mhtml:") != -1) {
            /* mhtml で始まる場合 (IE のプロトコル ?) */
            
            /* ! の前後に分割する */
            leafNameRe = /^(.*)\!([^\!]+)$/;
        }
        else if (location.indexOf ("\\") != -1) {
            /* Windows のパスの場合 */
            leagNameRe = /^(.*)\\([^\\]+)$/;
        }
        else if (location.indexOf ("/") != -1) {
            /* Mac OS X、Linux のパス、URI の場合 */
            leafNameRe = /^(.*)\/([^\/]+)$/;
        }
        else if (location.indexOf (":") != -1) {
            /* Mac OS 9 以前のパスの場合 */
            leafNameRe = /^(.*):([^:]+)$/;
        }
        
        
        if (leafNameRe != null) {
            /* 区切りが見付かった場合 */
            if (location.match (leafNameRe)) {
                /* ファイル名がある場合 */
                file.baseDir = RegExp.$1;
                file.leafName = RegExp.$2 + postfix;
            }
            else {
                /* ファイル名がない場合 */
                file.baseDir = location + postfix;
                file.leafName = "";
            }
        }
        else {
            /* ファイル名のみの場合 */
            file.baseDir = "";
            file.leafName = location + postfix;
        }
    }
};

/**
 * ファイルの管理をする
 */
var UnMHTFileManager = {
    fileProtocolHandler : null, /* nsIFileProtocolHandler  プロトコルの変換器 */
    
    separator : "\\",           /* String  ネイティブパスのセパレータ */
    systemDirectory : "",       /* String  システムディレクトリ
                                 *   Profile ディレクトリ/UnMHT となる */
    cacheDirectory : "",        /* String  キャッシュディレクトリ
                                 *   Profile ディレクトリ/UnMHT/Cache となる */
    
    /**
     * 初期化
     */
    init : function () {
        UnMHTFileManager.fileProtocolHandler
        = Components.classes ["@mozilla.org/network/io-service;1"]
        .getService (Components.interfaces.nsIIOService)
        .getProtocolHandler ("file")
        .QueryInterface (Components.interfaces.nsIFileProtocolHandler);
        
        /* 各種ディレクトリを作る */
        UnMHTFileManager.makeSystemDirectory ();
        UnMHTFileManager.makeCacheDirectory ();
    },
    
    /**
     * 現在のユーザの Profile ディレクトリを取得する
     *
     * @return  String
     *          現在のユーザの Profile ディレクトリ
     */
    getProfileDirectory : function () {
        var dirname;
        
        try {
            dirname
                = Components.classes ["@mozilla.org/file/directory_service;1"]
                .getService (Components.interfaces.nsIProperties)
                .get ("ProfD", Components.interfaces.nsIFile).path;
        }
        catch (e) {
            dirname = "";
        }
        
        return dirname;
    },
    
    /**
     * システムディレクトリを作成する
     */
    makeSystemDirectory : function () {
        var dirname = UnMHTFileManager.getProfileDirectory ();
        if (dirname.indexOf ("\\") != -1) {
            UnMHTFileManager.separator = "\\";
        }
        else if (dirname.indexOf ("/") != -1) {
            UnMHTFileManager.separator = "/";
        }
        else if (dirname.indexOf (":") != -1) {
            UnMHTFileManager.separator = ":";
        }
        UnMHTFileManager.systemDirectory = dirname
        + UnMHTFileManager.separator + "UnMHT";
        
        UnMHTFileManager.createDirectory (UnMHTFileManager.systemDirectory);
    },
    
    /**
     * キャッシュディレクトリを作成する
     */
    makeCacheDirectory : function () {
        UnMHTFileManager.cacheDirectory
        = UnMHTFileManager.systemDirectory
        + UnMHTFileManager.separator + "Cache";
        
        UnMHTFileManager.createDirectory (UnMHTFileManager.cacheDirectory);
    },
    
    /**
     * キャッシュを削除する
     *
     * @param  Number expire
     *         ミリ秒単位の経過時間
     *         0 なら即削除
     * @param  Boolean deleteExtractor
     *         展開情報も削除するか
     */
    clearCacheDirectory : function (expire, deleteExtractor) {
        try {
            var dir
            = Components.classes ["@mozilla.org/file/local;1"]
            .createInstance (Components.interfaces.nsILocalFile);
            dir.initWithPath (UnMHTFileManager.cacheDirectory);
            
            var now = new Date ().getTime ();
            
            if (dir.exists ()) {
                var entries = dir.directoryEntries;
                
                while (entries.hasMoreElements ()) {
                    var file = entries.getNext ();
                    file.QueryInterface (Components.interfaces.nsILocalFile);
                    
                    if (expire > 0) {
                        var createTime
                            = parseInt (file.leafName
                                        .replace (/_[0-9]*$/g, ""));
                        
                        if (now < createTime + expire) {
                            /* 作成から指定時間経過していない */
                            continue;
                        }
                    }
                    
                    if (deleteExtractor) {
                        var extractor = null;
                        var delete_urispec = "";
                        var extractName;
                        for (var urispec in UnMHT.extractors) {
                            extractName
                                = UnMHT.extractors [urispec].extractName;
                            if (extractName == file.leafName) {
                                extractor = UnMHT.extractors [urispec];
                                delete_urispec = urispec;
                                break;
                            }
                        }
                        
                        if (extractor) {
                            if (now < extractor.lastAccessTime + expire) {
                                /* 最終アクセスから指定時間経過していない */
                                continue;
                            }
                            
                            UnMHT.extractors [delete_urispec] = null;
                            delete UnMHT.extractors [delete_urispec];
                        }
                    }
                    file.remove (true);
                }
            }
        }
        catch (e) {
        }
    },
    
    /**
     * nsILocalFile オプジェクトを作成する
     * ファイルの実体は作成しない
     *
     * @param  String filename
     *         ファイル名
     * @return nsILocalFile
     */
    initFile : function (filename) {
        var file = null;
        try {
            file
                = Components.classes ["@mozilla.org/file/local;1"]
                .createInstance (Components.interfaces.nsILocalFile);
            file.initWithPath (filename);
        }
        catch (e) {
            file = null;
        }
        
        return file;
    },
    
    /**
     * ファイルを作成する
     *
     * @param  String filename
     *         ファイル名
     * @param  String text
     *         ファイルの内容
     */
    createFile : function (filename, text) {
        var file = null;
        try {
            file
                = Components.classes ["@mozilla.org/file/local;1"]
                .createInstance (Components.interfaces.nsILocalFile);
            file.initWithPath (filename);
            file.create (0x00, 0644);
        }
        catch (e) {
            file = null;
        }
        
        if (file) {
            try {
                var fstream
                = Components
                .classes ["@mozilla.org/network/file-output-stream;1"]
                .createInstance (Components.interfaces.nsIFileOutputStream);
                fstream.init (file, 0x02 | 0x08 | 0x20, 0644, 0);
                fstream.write (text, text.length);
                fstream.close ();
            }
            catch (e) {
            }
        }
    },
    
    /**
     * ファイルを読み込む
     *
     * @param  String filename
     *         ファイル名
     * @return String
     *         ファイルの内容
     */
    readFile : function (filename) {
        var text = "";
        var file = null;
        try {
            file
                = Components.classes ["@mozilla.org/file/local;1"]
                .createInstance (Components.interfaces.nsILocalFile);
            file.initWithPath (filename);
        }
        catch (e) {
            file = null;
        }
        
        if (file) {
            try {
                var fstream
                = Components
                .classes ["@mozilla.org/network/file-input-stream;1"]
                .createInstance (Components.interfaces.nsIFileInputStream);
                var sstream
                = Components
                .classes ["@mozilla.org/scriptableinputstream;1"]
                .createInstance (Components.interfaces
                                 .nsIScriptableInputStream);
                fstream.init (file, 0x01, 0444, 0);
                sstream.init (fstream);
                text = sstream.read (-1);
                sstream.close ();
                fstream.close ();
            }
            catch (e) {
                text = "";
            }
        }
        
        return text;
    },
    
    /**
     * ディレクトリを作成する
     *
     * @param  String dirname
     *         ディレクトリ名
     */
    createDirectory : function (dirname) {
        try {
            var dir
            = Components.classes ["@mozilla.org/file/local;1"]
            .createInstance (Components.interfaces.nsILocalFile);
            dir.initWithPath (dirname);
            if (!dir.exists ()) {
                dir.create (0x01, 0755);
            }
        }
        catch (e) {
        }
    },
    
    /**
     * ネイティブパスを file プロトコルに変換する
     *
     * @param  String filename
     *         ネイティブパス
     * @return String
     *         file プロトコル
     */
    getURLSpecFromFilename : function (filename) {
        var targetFile = UnMHTFileManager.initFile (filename);
        
        return UnMHTFileManager.fileProtocolHandler
        .getURLSpecFromFile (targetFile);
    },
    
    /**
     * ファイルを file プロトコルに変換する
     *
     * @param  nsILocalFile file
     *         ファイル
     * @return String
     *         file プロトコル
     */
    getURLSpecFromFile : function (file) {
        return UnMHTFileManager.fileProtocolHandler.getURLSpecFromFile (file);
    },
    
    /**
     * file プロトコルをネイティブパスに変換する
     *
     * @param  String uri
     *         file プロトコル
     * @return String
     *         ネイティブパス
     */
    getFilenameFromURLSpec : function (uri) {
        return UnMHTFileManager.fileProtocolHandler
        .getFileFromURLSpec (uri).path;
    },
    
    /**
     * file プロトコルをファイルに変換する
     *
     * @param  String uri
     *         file プロトコル
     * @return nsIFile
     *         ファイル、もしくは
     */
    getFileFromURLSpec : function (uri) {
        return UnMHTFileManager.fileProtocolHandler.getFileFromURLSpec (uri);
    },
    
    /**
     * パスを展開、連結する
     *
     * @param  String base
     *         親ディレクトリのパス
     * @param  String sub
     *         相対パス、もしくは絶対パス
     * @return String
     *         連結したパス
     */
    jointPath : function (base, sub) {
        var i;
        var path;
        var sep;
        
        var protocol;
        var host;
        
        if (base == null) {
            return sub;
        }
        
        /* セパレータを検出 */
        if (base.indexOf ("\\") != -1) {
            /* Windows のパスの場合 */
            sep = "\\";
        }
        else if (base.indexOf ("/") != -1) {
            /* Mac OS X、Linux のパス、URI の場合 */
            sep = "/";
        }
        else if (base.indexOf (":") != -1) {
            /* Mac OS 9 以前のパスの場合 */
            sep = ":";
        }
        else {
            /* 区切りが見付からない場合連結できないので
             * サブのみ返す */
            return sub;
        }
        
        if (base.match (/^([A-Za-z0-9\-]+:\/\/)([^\/]+)(.*)$/)) {
            /* URI の場合 */
            protocol = RegExp.$1;
            host = RegExp.$2;
            base = RegExp.$3;
        }
        else if (base.match (/^([A-Za-z]+:)(.*)$/)) {
            /* Windows のネイティブなパスの場合 */
            protocol = RegExp.$1;
            host = "";
            base = RegExp.$2;
        }
        else if (base.match (/^(\\)(\\.*)$/)) {
            /* Windows のネットワークドライブの場合 */
            protocol = RegExp.$1;
            host = "";
            base = RegExp.$2;
        }
        else {
            /* その他のパスの場合 */
            protocol = "";
            host = "";
        }
        
        if (sub.match (/^([A-Za-z0-9\-]+:\/\/)([^\/]+)(.*)$/)
            || sub.match (/^([A-Za-z]+:)(.*)$/)
            || sub.match (/^(\\)(\\.*)$/)) {
            /* sub が URI、 Windows のネイティブな絶対パス、
             * ネットワークドライブの場合 */
            return sub;
        }
        
        if (sub.substring (0, 1) == sep) {
            /* sub が絶対パスの場合 */
            base = "";
        }
        
        path = base + sep + sub;
        var sepRegExp
        = new RegExp ("[^"
                      + sep.replace (/(\\\[\]\(\)\^\,\.\{\}\|\?\!\-\*\+\$)/,
                                     "\\$1")
                      + "]*",
                      "g");
        var newNames = [];
        var isDir = false;
        if (path.match
            (new RegExp ("["
                         + sep.replace (/(\\\[\]\(\)\^\,\.\{\}\|\?\!\-\*\+\$)/,
                                        "\\$1")
                         + "]$"))) {
            isDir = true;
        }
        
        /* パスを解析するだけなので代入はしない */
        path.replace
        (sepRegExp,
         function (matched) {
            if (matched == ".") {
            }
            else if (matched == "..") {
                newNames.pop ();
            }
            else if (matched == "") {
            }
            else {
                newNames.push (matched);
            }
            return "";
        });
        
        path = "";
        for (i = 0; i < newNames.length; i ++) {
            path += sep;
            path += newNames [i];
        }
        if (isDir) {
            path += sep;
        }
        
        path = protocol + host + path;
        
        return path;
    }
};

/**
 * 文字コード変換器
 */
var UnMHTConverter = {
    converter : null, /* nsIScriptableUnicodeConverter  文字コード変換器 */
    
    /**
     * 初期化
     */
    init : function () {
        UnMHTConverter.converter
        = Components.classes ["@mozilla.org/intl/scriptableunicodeconverter"]
        .getService (Components.interfaces.nsIScriptableUnicodeConverter);
    },
    
    /**
     * UTF-16 から ISO-2022-JP に変換する
     *
     * @param  String text
     *         UTF-16 の文字列
     * @return String
     *         ISO-2002-JP に変換した文字列
     */
    convertToISO2022JP : function (text) {
        UnMHTConverter.converter.charset = "iso-2022-jp";
        return UnMHTConverter.converter.ConvertFromUnicode (text);
    },
    
    /**
     * HTML に使えない文字をエスケープする
     * 
     * @param  String text
     *         エスケープする文字列
     * @return String
     *         エスケープした文字列
     */
    escapeEntity : function (text) {
        return text
        .replace (/&/g, "&amp;")
        .replace (/\"/g, "&quot;")
        .replace (/\'/g, "&#x27;")
        .replace (/</g, "&lt;")
        .replace (/>/g, "&gt;")
        .replace (/\xa0/g, "&nbsp;");
    },
    
    /**
     * HTML に使えない文字のエスケープを解除する
     * 
     * @param  String text
     *         エスケープを解除する文字列
     * @return String
     *         エスケープを解除した文字列
     */
    unescapeEntity : function (text) {
        return text
        .replace (/&gt;/g, ">")
        .replace (/&lt;/g, "<")
        .replace (/&quot;/g, "\"")
        .replace (/&#x27;/g, "\'")
        .replace (/&nbsp;/g, " ")
        .replace (/&amp;/g, "&");
    },
    
    /**
     * Unicode から変換する
     *
     * @param  String text
     *         変換する文字列
     * @param  String charset
     *         変換先の文字コード
     * @return String
     *         変換した文字列
     */
    convertFromUnicode : function (text, charset) {
        if (UnMHT.mode == 1) {
            var text2;
            
            UnMHTConverter.converter.charset = charset;
            
            try {
                text2 = UnMHTConverter.converter.ConvertFromUnicode (text);
            }
            catch (e) {
                text2 = text;
            }
            
            return text2;
        }
        else if (UnMHT.mode == 2) {
            return text;
        }
        
        return text;
    },
    
    /**
     * Unicode に変換する
     *
     * @param  String text
     *         変換する文字列
     * @param  String charset
     *         変換元の文字コード
     * @return String
     *         変換した文字列
     */
    convertToUnicode : function (text, charset) {
        if (UnMHT.mode == 1) {
            var text2;
            UnMHTConverter.converter.charset = charset;
            
            try {
                text2 = UnMHTConverter.converter.ConvertToUnicode (text);
            }
            catch (e) {
                text2 = text;
            }
            
            return text2;
        }
        else if (UnMHT.mode == 2) {
            return text;
        }
        
        return text;
    },
    
    /**
     * encoded word をデコードする
     *
     * @param  String text
     *         デコードする文字列
     * @param  Boolean utf16
     *         text が UTF-16 であるかどうか
     * @return String
     *         デコードした文字列
     */
    decode_ew : function (text, utf16) {
        if (text.match (/^=\?([^\?]+)\?([^\?])\?([^\?]+)\?=$/)) {
            var encodedCharset = RegExp.$1;
            var encodedType = RegExp.$2;
            var encodedText = RegExp.$3;
            
            if (encodedType == "Q") {
                encodedText
                    = encodedText.replace
                    (/=([A-Fa-f0-9][A-Fa-f0-9])/g,
                     function (dummy, matched) {
                        return String.fromCharCode ("0x" + matched);
                    });
            }
            else if (encodedType == "B") {
                if (UnMHT.mode == 1) {
                    encodedText = atob (encodedText);
                }
                else if (UnMHT.mode == 2) {
                    encodedText = UnMHTConverter.atob (encodedText);
                }
            }
            
            return UnMHTConverter.convertToUnicode (encodedText,
                                                    encodedCharset);
        }
        
        if (utf16) {
            return text;
        }
        
        return UnMHTConverter.convertToUnicode (text, "shift_jis");
    },
    
    /**
     * Base64 をデコードする
     *
     * @param  String text
     *         デコードする文字列
     * @return String
     *         デコードした文字列
     */
    atob : function (text) {
        var b
        = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
        
        var result = "";
        var c, part1, part2, part3, part4;

        for (var i = 0; i < text.length; i += 4) {
            part1 = b.indexOf (text.substr (i, 1));
            part2 = b.indexOf (text.substr (i + 1, 1));
            part3 = b.indexOf (text.substr (i + 2, 1));
            part4 = b.indexOf (text.substr (i + 3, 1));
            
            if (part1 != -1 && part2 != -1) {
                result += String.fromCharCode ((part1 << 2)
                                               | (part2 >> 4));
            }
            if (part2 != -1 && part3 != -1 && part3 != 64) {
                result += String.fromCharCode (((part2 & 0x0f) << 4)
                                               | (part3 >> 2));
            }
            if (part3 != -1 && part4 != -1 && part4 != 64) {
                result += String.fromCharCode (((part3 & 0x03) << 6)
                                               | (part4));
            }
        }
        
        return result;
    },
    
    /**
     * Base64 にエンコードする
     *
     * @param  String text
     *         エンコードする文字列
     * @return String
     *         エンコードした文字列
     */
    btoa8 : function (text) {
        var b
        = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
        
        var result = "";
        var c;
        var part1, part2, part3, part4;
        
        for (var i = 0; i < text.length; i += 3) {
            c = text.charCodeAt (i) & 0xff;
            part1 = c >> 2;
            part2 = (c & 0x3) << 4;
            if (i + 1 == text.length) {
                part3 = 64;
                part4 = 64;
            }
            else {
                c = text.charCodeAt (i + 1) & 0xff;
                part2 |= (c & 0xf0) >> 4;
                part3 = (c & 0x0f) << 2;
                if (i + 2 == text.length) {
                    part4 = 64;
                }
                else {
                    c = text.charCodeAt (i + 2) & 0xff;
                    part3 |= (c & 0xc0) >> 6;
                    part4 = c & 0x3f;
                }
            }
            result
                += b.substr (part1, 1)
                + b.substr (part2, 1)
                + b.substr (part3, 1)
                + b.substr (part4, 1);
        }
        return result;
    },
    
    /**
     * UTF-16 を Base64 にエンコードする
     *
     * @param  String text
     *         エンコードする文字列
     * @return String
     *         エンコードした文字列
     */
    btoa16 : function (text) {
        var b
        = "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";
        
        var result = "";
        var c;
        var part1a, part2a, part3a, part4a;
        var part1b, part2b, part3b, part4b;
        
        for (var i = 0; i < text.length; i += 3) {
            c = (text.charCodeAt (i) >> 8) & 0xff;
            part1a = c >> 2;
            part2a = (c & 0x3) << 4;
            c = text.charCodeAt (i) & 0xff;
            part2a |= (c & 0xf0) >> 4;
            part3a = (c & 0x0f) << 2;
            if (i + 1 == text.length) {
                part4a = 64;
                partab = -1;
            }
            else {
                c = (text.charCodeAt (i + 1) >> 8) & 0xff;
                part3a |= (c & 0xc0) >> 6;
                part4a = c & 0x3f;
                c = text.charCodeAt (i + 1) & 0xff;
                part1b = c >> 2;
                part2b = (c & 0x3) << 4;
                if (i + 2 == text.length) {
                    part3b = 64;
                    part4b = 64;
                }
                else {
                    c = (text.charCodeAt (i + 2) >> 8) & 0xff;
                    part2b |= (c & 0xf0) >> 4;
                    part3b = (c & 0x0f) << 2;
                    c = text.charCodeAt (i + 2) & 0xff;
                    part3b |= (c & 0xc0) >> 6;
                    part4b = c & 0x3f;
                }
            }
            
            result
                += b.substr (part1a, 1)
                + b.substr (part2a, 1)
                + b.substr (part3a, 1)
                + b.substr (part4a, 1);
            
            if (part1b != -1) {
                result
                    += b.substr (part1b, 1)
                    + b.substr (part2b, 1)
                    + b.substr (part3b, 1)
                    + b.substr (part4b, 1);
            }
        }
        return result;
    }
};
/* Opera/IE/Safari 版, QuickLook 版に移植する部分 (1) ---- ここまで ---- */

/**
 * ドキュメントごとの情報
 */
function UnMHTDocumentParam () {
}
UnMHTDocumentParam.prototype = {
    targetDocument : null,
    history_listener : null
};

/**
 * 本体
 */
var UnMHT = {
    messages : null,               /* nsIStringBundle  メッセージ */
    documentParams : new Array (), /* Array  ドキュメントごとの情報 */
    latestParam : null,            /* UnMHTDocumentParam
                                    *   最近使ったドキュメントごとの情報 */
    
    isOld : false,                 /* Boolean  古い Mozilla Suite か */
    isThunderbird : false,         /* Boolean  Thunderbird か */
    
    initialized : false,           /* Boolean  初期化フラグ */
    
    /* Opera/IE/Safari 版, QuickLook 版に移植する部分 (2) ---- ここから ---- */
    enableAll : false,             /* Boolean  全機能の ON／OFF */
    
    extractors : new Object (),    /* Obejct  展開の情報を保持しておく
                                    * <String 展開したファイル名の URI 表記,
                                    *  UnMHTExtractor 展開の情報> */
    
    mode : 1,                      /* Number  動作モード
                                    *   1: Firefox/Mozilla Suite
                                    *   2: Opera/Safari */
    
    /* [一般] タブの設定 */
    enableMemoryCache : true,     /* Boolean  メモリキャッシュモード */
    enableNolimit : false,        /* Boolean
                                   *   展開中はスクリプトの実行時間に制限をしない */
    enableFastExtract : false,    /* Boolean  展開を高速化する */
    
    cacheExpire : 300000,         /* Number  キャッシュの保持時間 [ミリ秒] */
    enableCacheExpire : false,    /* Boolean  キャッシュ自動削除 */
    
    enableSkipPPTWarning : false, /* Boolean  PowerPoint の警告を飛ばす */
    openMultiple : "",            /* String  複数のファイルを含む MHT を開く時
                                   *   tabs: 全てのページをタブとして開く
                                   *   index: インデックスページを表示する */
    
    enableFilter : false,      /* Boolean  フィルタ */
    filterList : new Array (), /* Array  フィルタリスト
                                * [[String 種類,
                                *   String/RegExp パターン,
                                *   Boolean 正規表現のフラグ], ...]
                                * String 種類
                                *   "hostname":  ホスト名
                                *   "leafname":  ファイル名
                                *   "extension": 拡張子
                                *   "location":  アドレス全部
                                *   "mimetype":  MIME タイプ */
    /* Opera/IE/Safari 版, QuickLook 版に移植する部分 (2) ---- ここまで ---- */
    
    /* [保存] タブの設定 */
    saveFilename : "leafname",            /* String
                                           *   保存時のファイル名 */
    enableSaveContextMenu : false,        /* Boolean  コンテキスメニュー */
    enableSaveShortcut : false,           /* Boolean  ショートカット */
    saveShortcutKeycode : 0,              /* Number  ショートカットのキーコード */
    saveShortcutModifiersAlt : false,     /* Boolean  ショートカットの Alt */
    saveShortcutModifiersCtrl : false,    /* Boolean  ショートカットの Ctrl */
    saveShortcutModifiersMeta : false,    /* Boolean  ショートカットの Meta */
    saveShortcutModifiersShift : false,   /* Boolean  ショートカットの Shift */
    
    saveFilenameCustom : "",    /* String  カスタムファイル名テンプレート */
    saveFilenameCustomAM : "",  /* String  カスタムファイル名テンプレート a.m. */
    saveFilenameCustomPM : "",  /* String  カスタムファイル名テンプレート p.m. */
    
    /* [その他] タブの設定 */
    enableToolbarPreferences : false,   /* Boolean
                                         *   ツールバーにパネルを表示する */
    enableStatusbarPreferences : false, /* Boolean
                                         *   ステータスバーにパネルを表示する */
    
    /**
     * ドキュメントごとの情報を追加する
     *
     * @param  HTMLDocument targetDocument
     *         対象のドキュメント
     */
    addDocumentParam : function (targetDocument) {
        var param = new UnMHTDocumentParam ();
        param.targetDocument = targetDocument;
        UnMHT.documentParams.push (param);
        UnMHT.latestParam = param;
    },
    
    /**
     * ドキュメントごとの情報を削除する
     *
     * @param  HTMLDocument targetDocument
     *         対象のドキュメント
     */
    deleteDocumentParam : function (targetDocument) {
        for (var i = 0; i < UnMHT.documentParams.length; i ++) {
            var tmp = UnMHT.documentParams [i];
            if (tmp.targetDocument == targetDocument) {
                UnMHT.documentParams.splice (i, 1);
                tmp.targetDocument = null;
                tmp.location_info = null;
                tmp = null;
                break;
            }
        }
        UnMHT.latestParam = null;
    },
    
    /*
     * ドキュメントごとの情報を取得する
     *
     * @param  HTMLDocument targetDocument
     *         対象のドキュメント
     * @return UnMHTDocumentParam
     *         ドキュメントごとの情報
     */
    getDocumentParam : function (targetDocument) {
        var latest = UnMHT.latestParam;
        if (latest
            && latest.targetDocument == targetDocument) {
            return latest;
        }
        
        for (var i = 0; i < UnMHT.documentParams.length; i ++) {
            if (UnMHT.documentParams [i].targetDocument == targetDocument) {
                return UnMHT.documentParams [i];
            }
        }
        
        return null;
    },
    
    /**
     * SeaMonkey でロケールを修正する
     */
    fixLocale : function () {
        var locales
        = ["en-US",
           "cs-CZ",
           "de-DE",
           "en-GB",
           "es-ES",
           "fr-FR",
           "hu-HU",
           "it-IT",
           "ja-JP",
           "pl-PL",
           "pt-BR",
           "ru-RU",
           "uk-UK",
           "vi-VN",
           "zh-CN",
           "zh-TW"];
        
        try {
            var locale = "en-US";
            try {
                var prefBranch
                    = Components.classes ["@mozilla.org/preferences-service;1"]
                    .getService (Components.interfaces.nsIPrefBranch);
                
                try {
                    locale
                        = prefBranch.getComplexValue
                        ("general.useragent.locale",
                         Components.interfaces.nsIPrefLocalizedString).data;
                }
                catch (e) {
                    locale
                        = prefBranch.getCharPref ("general.useragent.locale");
                }
            }
            catch (e) {
            }
            
            var select = null;
            for (var i = 0; i < locales.length; i ++) {
                if (locales [i] == locale) {
                    select = locales [i];
                    break;
                }
            }
            if (!select) {
                for (var i = 0; i < locales.length; i ++) {
                    if (locales [i].substr (0, 2) == locale.substr (0, 2)) {
                        select = locales [i];
                        break;
                    }
                }
            }
            if (!select) {
                select = locales [0];
            }
            
            var registry
                = Components.classes ["@mozilla.org/chrome/chrome-registry;1"]
                .getService (Components.interfaces.nsIChromeRegistrySea);
            registry.selectLocaleForPackage (select, "unmht", false);
            registry.selectLocaleForPackage (select, "unmht", true);
        }
        catch (e) {
        }
    },
    
    /**
     * ウィンドウが開かれたイベント
     * 初期化とイベントのフックを行う
     */
    onLoad : function () {
        if (UnMHT.initialized) {
            return;
        }
        UnMHT.initialized = true;
        
        var commandset = document.getElementById ("mainCommandSet");
        if (!commandset) {
            /* SeaMonkey では mainCommandSet が無い */
            var mainWindow = document.getElementById ("main-window");
            if (mainWindow) {
                commandset = document.createElement ("commandset");
                commandset.id = "mainCommandSet";
                var command;
                command = document.createElement ("command");
                command.id = "unmht-command-save";
                command.setAttribute ("disabled", "true");
                command.setAttribute ("oncommand",
                                      "UnMHTUIManager.save (false);");
                commandset.appendChild (command);
                command = document.createElement ("command");
                command.id = "unmht-command-save-multi";
                command.setAttribute ("oncommand",
                                      "UnMHTUIManager.savemulti ();");
                commandset.appendChild (command);
                mainWindow.appendChild (commandset);
            }
        }
        
        try {
            var id
            = Components.classes ["@mozilla.org/xre/app-info;1"]
            .getService (Components.interfaces.nsIXULAppInfo).ID;
            if (id == "{3550f703-e582-4d05-9a08-453d09bdfdc6}") {
                /* Thunderbird */
                UnMHT.isThunderbird = true;
            }
        } catch (e) {}
        
        if (!UnMHT.isThunderbird) {
            var tabbrowser = document.getElementById ("content");
            if (!tabbrowser) {
                return;
            }
            if ("addProgressListener" in tabbrowser) {
                tabbrowser.addProgressListener
                (UnMHTBrowserProgressListener,
                 Components.interfaces.nsIWebProgress.NOTIFY_LOCATION);
            }
        }
        else {
            var messagepane = document.getElementById ("messagepane");
            if (messagepane) {
                messagepane.addProgressListener
                    (UnMHTBrowserProgressListener,
                     Components.interfaces.nsIWebProgress.NOTIFY_LOCATION);
            }
        }
        
        if (parseInt (navigator.productSub) <= 20030621) {
            /* 古い Mozilla Suite の場合 */
            UnMHT.isOld = true;
        }
        
        UnMHT.fixLocale ();
        
        UnMHT.messages
        = Components.classes ["@mozilla.org/intl/stringbundle;1"]
        .getService (Components.interfaces.nsIStringBundleService)
        .createBundle ("chrome://unmht/locale/unmht.properties");
        
        UnMHTConfigManager.init ();
            
        UnMHTFileManager.init ();
            
        UnMHTConverter.init ();
            
        UnMHTUIManager.showPanel ();
        UnMHTUIManager.setPanelStatus ();
        
        if (!UnMHT.isThunderbird) {
            window.addEventListener
                ("keydown",
                 function () {
                    UnMHT.onKeyDown (arguments [0]);
                }, true);
        }
        
        if (!UnMHT.isThunderbird) {
            var popup;
            popup = document.getElementById ("menu_FilePopup");
            if (popup) {
                popup
                    .addEventListener
                    ("popupshowing",
                     function () {
                        UnMHTUIManager.setFileMenuPopup (arguments [0]);
                    }, false);
            }
        }
        
        if (!UnMHT.isThunderbird) {
            sidebar = document.getElementById ("sidebar");
            if (sidebar) {
                sidebar
                    .addEventListener
                    ("DOMContentLoaded",
                     function () {
                        UnMHT.checkSidebar (arguments [0]);
                    }, false);
            }
        }
        
        var menu = document.getElementById ("contentAreaContextMenu");
        if (menu) {
            menu.addEventListener
                ("popupshowing", 
                 function () {
                    UnMHT.setContextMenu (arguments [0]);
                }, false);
        }
        
        if (!UnMHT.isThunderbird) {
            var appcontent = document.getElementById ("appcontent");
            if (!appcontent) {
                appcontent = document.getElementById ("content");
            }
            if (appcontent) {
                appcontent.addEventListener
                    ("DOMContentLoaded",
                     function () {
                        UnMHT.onDOMContentLoaded (arguments [0]);
                    }, false);
                
                try {
                    if (typeof Akahuku != "undefined") {
                        /* Akahuku よりも先に動くために
                         * イベントの順番を入れ替える */
                        appcontent.removeEventListener
                            ("DOMContentLoaded",
                             Akahuku.onDOMContentLoaded,
                             false);
                        appcontent.addEventListener
                            ("DOMContentLoaded",
                             Akahuku.onDOMContentLoaded,
                             false);
                    }
                }
                catch (e) {
                }
                
                try {
                    if (typeof Aima_Aimani != "undefined") {
                        /* Akahuku が Aima_Aimani よりも先に動くために
                         * イベントの順番を入れ替える */
                        appcontent.removeEventListener
                            ("DOMContentLoaded",
                             Aima_Aimani.onDOMContentLoaded,
                             false);
                        appcontent.addEventListener
                            ("DOMContentLoaded",
                             Aima_Aimani.onDOMContentLoaded,
                             false);
                    }
                }
                catch (e) {
                }
            }
        }
    },
    
    /**
     * キーが押されたイベント
     *
     * @param  Event event
     *         対象のイベント
     */
    onKeyDown : function (event) {
        if (UnMHT.enableAll
            && UnMHT.enableSaveShortcut) {
            if (UnMHT.saveShortcutKeycode == event.keyCode
                && UnMHT.saveShortcutModifiersAlt == event.altKey
                && UnMHT.saveShortcutModifiersCtrl == event.ctrlKey
                && UnMHT.saveShortcutModifiersMeta == event.metaKey
                && UnMHT.saveShortcutModifiersShift == event.shiftKey) {
                
                var tabbrowser = document.getElementById ("content");
                var targetDocument = tabbrowser.contentDocument;
                if (!UnMHT.isSavable (targetDocument)) {
                    return;
                }
                
                UnMHTUIManager.save (false);
                
                event.preventDefault ();
                event.stopPropagation ();
            }
        }
    },
    
    /**
     * 保存可能かどうかを調べる
     *
     * @param  HTMLDocument targetDocument
     *         対象のドキュメント
     * @return Boolean
     *         保存可能かどうか
     */
    isSavable : function (targetDocument) {
        try {
            if (gIeTab.isIeEngine ()) {
                return false;
            }
        }
        catch (e) {
        }
        
        if (UnMHT.isThunderbird) {
            if (targetDocument.location.href == "about:blank") {
                return false;
            }
        }
        
        if ("__unmht_no_save_" in targetDocument) {
            return false;
        }
        else if (targetDocument.contentType.match (/^text/)
            || targetDocument.contentType.match (/\/x(ht)?ml$/)) {
            return true;
        }
        else {
            return false;
        }
    },
    
    /**
     * メニューが開かれるイベント
     * メニューの項目の表示／非表示を設定する
     *
     * @param  Event event
     *         対象のイベント
     */
    setContextMenu : function (event) {
        var menuitem;
        
        var tabbrowser = document.getElementById ("content");
        var targetDocument = tabbrowser.contentDocument;
        
        if (UnMHT.enableSaveContextMenu
            && UnMHT.isSavable (targetDocument)) {
            menuitem
            = document.getElementById ("unmht-context-menuitem-save");
            if (menuitem) {
                menuitem.hidden = false;
            }
            menuitem
            = document.getElementById ("unmht-context-menuitem-separator");
            if (menuitem) {
                menuitem.hidden = false;
            }
        }
        else {
            menuitem
                = document.getElementById ("unmht-context-menuitem-save");
            if (menuitem) {
                menuitem.hidden = true;
            }
            menuitem
                = document.getElementById
                ("unmht-context-menuitem-separator");
            if (menuitem) {
                menuitem.hidden = true;
            }
        }
    },
    
    /**
     * サイドバーの内容が ScrapBook かどうかチェック
     * ScrapBook ならばメニューの項目を追加する
     *
     * @param  Event event
     *         対象のイベント
     */
    checkSidebar : function (event) {
        var sidebarDocument = event.target;
        popup = sidebarDocument.getElementById ("sbPopup");
        var item = sidebarDocument.getElementById ("sbPopupTools");
        if (popup && item) {
            var newItem;
            label
                = UnMHT.messages.GetStringFromName ("save_title");
            newItem = sidebarDocument.createElement ("menuitem");
            newItem.id = "unmht-scrapbook-save";
            newItem.setAttribute ("label", label);
            newItem
                .addEventListener
                ("command",
                 function () {
                    UnMHTUIManager.save (true);
                }, false);
            popup.insertBefore (newItem, item);
            
            popup
                .addEventListener
                ("popupshowing",
                 function () {
                    UnMHTUIManager.setScrapBookPopup (arguments [0]);
                }, false);
        }
    },
    
    /**
     * ウィンドウが閉じられたイベント
     * キャッシュの削除を行う
     */
    onUnload : function () {
        if (!UnMHT.initialized) {
            return;
        }
        
        UnMHTConfigManager.term ();
        UnMHT.clearCache (0, false);
        
        UnMHT.initialized = false;
    },
    
    /**
     * body の unload イベント
     * 各種データを削除する
     *
     * @param  HTMLDocument targetDocument
     *         対象のドキュメント
     * @param  Event event
     *         対象のイベント
     */
    onBodyUnload : function (targetDocument, event) {
        var listener;
        var param;
        
        param = UnMHT.getDocumentParam (targetDocument);
        if (!param) {
            return;
        }
        
        listener = param.history_listener;
        if (listener) {
            try {
                listener.destruct ();
            }
            catch (e) {
            }
        }
        param.history_listener = null;
        
        UnMHT.deleteDocumentParam (targetDocument);
    },
    
    /**
     * コンテンツがロードされたイベント
     * mht ファイルの展開、アドレスの変換を行う
     *
     * @param  Event event
     *         対象のイベント
     */
    onDOMContentLoaded : function (event) {
        var targetWindow = event.target.defaultView;
        var targetDocument = targetWindow.document;
        
        if (Components.interfaces.nsIPrefBranch2 == undefined) {
            /* 監視していない場合にのみ設定を取得する */
            UnMHTConfigManager.getConfigurationFromPreferencesAll ();
        }
        
        if (UnMHT.enableAll) {
            if (targetDocument.location.href.match (/[^\/]\.mht$/)) {
                /* Content-Type 指定のない mht ファイルだった場合 */
                
                if (targetDocument.location.href.match
                    (/^chrome:\/\/ietab\//)) {
                    /* IETab がハンドル済み */
                    return;
                }
                
                var uri
                = Components.classes ["@mozilla.org/network/standard-url;1"]
                .createInstance (Components.interfaces.nsIURI);
                uri.spec = targetDocument.location.href;
                
                UnMHT.loadMHT (uri, targetWindow,
                               true,  /* 開いているドキュメントを使用する */
                               true,  /* 履歴を置き換える */
                               1,     /* 強制的に展開する */
                               "",    /* ルートドキュメントを開く */
                               true); /* キャッシュを使用する */
            }
            else if (UnMHT.protocolHandler.isUnMHTURI
                     (targetDocument.location.href)) {
                /* UnMHT の開いたファイルだった場合 */
                
                UnMHT.modifyRootDocument (targetDocument, targetWindow);
                
                if (UnMHT.openMultiple == "tabs") {
                    var param
                        = UnMHT.protocolHandler.getUnMHTURIParam
                        (targetDocument.location.href);
                    var original = param.original;
                    var refName = param.refName;
                    if (refName == ""
                        && original
                        && original in UnMHT.extractors) {
                        extractor = UnMHT.extractors [original];
                        if ("x-unmht-tabs" in extractor.firstFile.headerMap) {
                            /* 複数のファイルを含む MHT のインデックスを開いた */
                            UnMHT.replaceTabs (targetDocument,
                                targetWindow);
                        }
                    }
                }
            }
        }
    },
    
    /**
     * UnMHT の開いたファイルのリンクを書き換える
     * 
     * @param  HTMLDocument targetDocument
     *         対象のドキュメント
     * @param  Window targetWindow
     *         対象のウィンドウ
     */
    modifyRootDocument : function (targetDocument, targetWindow) {
        if (!UnMHT.protocolHandler.isUnMHTURI (targetDocument.location.href)) {
            return;
        }
        
        var param
        = UnMHT.protocolHandler.getUnMHTURIParam (targetDocument.location.href);
        var original = param.original;
        var protocol = param.protocol;
        var refName = param.refName;
        if (protocol != "cache"
            && protocol != "error"
            && protocol != "dummy"
            && protocol != "cid") {
            var extractor = null;
            var file = null;
            if (original
                && original in UnMHT.extractors) {
                /* 展開済みのファイルだった場合 */
                extractor = UnMHT.extractors [original];
                        
                if (refName
                    && refName in extractor.refFiles) {
                    file = extractor.refFiles [refName];
                }
                else {
                    file = extractor.rootFile;
                }
                        
                if (file == extractor.rootFile) {
                    /* ルートドキュメントなので
                     * リロードとアンロードをフックする */
                    UnMHT.hookEvent (targetDocument, targetWindow);
                }
                        
                /* base を削除する */
                var base = file.baseDir;
                if (file.baseElementDir) {
                    base = file.baseElementDir;
                }
                nodes = targetDocument.getElementsByTagName ("base");
                for (i = 0; i < nodes.length;) {
                    if (nodes [i].hasAttribute ("href")) {
                        nodes [i].parentNode.removeChild (nodes [i]);
                    }
                    else {
                        i ++;
                    }
                }
                
                /* リンク先を書き換える */
                nodes = targetDocument.getElementsByTagName ("a");
                for (i = 0; i < nodes.length; i ++) {
                    var path = nodes [i].getAttribute ("href");
                    if (!path) {
                        continue;
                    }
                    if (path.substr (0, 7) == "mailto:") {
                        /* mailto: は置き換えない */
                        continue;
                    }
                    if ("className" in nodes [i]
                        && nodes [i].className == "unmht_link_to_original") {
                        /* オリジナルへのリンクは置き換えない */
                        continue;
                    }
                            
                    var list
                        = UnMHT.checkFile (extractor, file, path, false);
                    
                    var newPath = "";
                    if (list [0] != -1
                        && list [1]) {
                        /* ファイルが MHT に含まれており、展開した場合 */
                        newPath
                            = extractor.rootURI
                            + list [1].refName + list [2];
                    }
                    else {
                        /* ファイルが MHT に含まれていないか
                         * 展開しなかった場合 */
                        /* base を削除したので置き換える */
                        newPath = UnMHTFileManager.jointPath (base, path);
                    }
                    
                    if (path != newPath) {
                        nodes [i].setAttribute ("__unmht_href", path);
                        nodes [i].setAttribute ("href", newPath);
                    }
                }
                /* action を書き換える */
                nodes = targetDocument.getElementsByTagName ("form");
                for (i = 0; i < nodes.length; i ++) {
                    var path = nodes [i].getAttribute ("action");
                    if (!path) {
                        continue;
                    }
                    
                    var list
                        = UnMHT.checkFile (extractor, file, path, false);
                    
                    var newPath = "";
                    if (list [0] != -1
                        && list [1]) {
                        /* ファイルが MHT に含まれており、展開した場合 */
                        newPath
                            = extractor.rootURI
                            + list [1].refName + list [2];
                    }
                    else {
                        /* ファイルが MHT に含まれていないか
                         * 展開しなかった場合 */
                        /* base を削除したので置き換える */
                        newPath = UnMHTFileManager.jointPath (base, path);
                    }
                    
                    if (path != newPath) {
                        nodes [i].setAttribute ("__unmht_action", path);
                        nodes [i].setAttribute ("action", newPath);
                    }
                }
            }
            else {
                /* 未展開のファイルだった場合 */
                        
                var uri
                    = Components.classes ["@mozilla.org/network/standard-url;1"]
                    .createInstance (Components.interfaces.nsIURI);
                uri.spec = original;
                UnMHT.loadMHT (uri, targetWindow,
                               false,  /* ドキュメント無し */
                               true,   /* 履歴を置き換える */
                               0,      /* 展開は設定に任せる */
                               original,  /* 指定されたファイルを開く */
                               false); /* キャッシュは使用しない */
            }
        }
    },
    
    /**
     * インデックスファイルをタブに置き換える
     * 
     * @param  HTMLDocument targetDocument
     *         対象のドキュメント
     * @param  Window targetWindow
     *         対象のウィンドウ
     */
    replaceTabs : function (targetDocument, targetWindow) {
        var nodes = targetDocument.getElementsByTagName ("a");
        var tabbrowser = document.getElementById ("content");
        
        try {
            for (var i = 0; i < nodes.length; i ++) {
                var node = nodes [i];
                if ("className" in node
                    && node.className == "unmht-tabs") {
                    tabbrowser.addTab (node.href, null);
                }
            }
        
            var tab = UnMHT.getTabForWindow (targetWindow);
            if (tab) {
                tabbrowser.removeTab (tab);
            }
        }
        catch (e) {
        }
    },
    
    /**
     * 対象のウィンドウを持つ tab オブジェクトを取得する
     * 
     * @param  Window targetWindow
     *         対象のウィンドウ
     * @return Tab
     *         見付からなければ null
     */
    getTabForWindow : function (targetWindow) {
        var tabbrowser = document.getElementById ("content");
        if (tabbrowser.mTabContainer) {
            for (i = 0; i < tabbrowser.mTabContainer.childNodes.length; i ++) {
                var tab = tabbrowser.mTabContainer.childNodes [i];
                if (tab.linkedBrowser
                    && tab.linkedBrowser
                    .contentWindow == targetWindow) {
                    return tab;
                }
            }
            
            if ("mPanelContainer" in tabbrowser
                && "childNodes" in tabbrowser.mPanelContainer) {
                for (i = 0; i < tabbrowser.mPanelContainer.childNodes.length;
                     i ++) {
                    var b = tabbrowser.mPanelContainer.childNodes [i];
                    if (b.contentWindow == targetWindow) {
                        return tabbrowser.mTabContainer.childNodes [i];
                    }
                }
            }
        }
        
        return null;
    },
    
    /**
     * リロードとアンロードをフックする
     * 
     * @param  HTMLDocument targetDocument
     *         対象のドキュメント
     * @param  Window targetWindow
     *         対象のウィンドウ
     */
    hookEvent : function (targetDocument, targetWindow) {
        try {
            var nav
            = targetWindow
            .QueryInterface (Components.interfaces.nsIInterfaceRequestor)
            .getInterface (Components.interfaces.nsIWebNavigation);
                                
            var listener = new UnMHTSHistoryListener ();
            listener.targetWindow = targetWindow;
            nav.sessionHistory.addSHistoryListener (listener);
            
            UnMHT.addDocumentParam (targetDocument);
            UnMHT.getDocumentParam (targetDocument).history_listener
            = listener;
            
            targetWindow.addEventListener
            ("unload",
             function () {
                UnMHT.onBodyUnload (targetDocument, arguments [0]);
            }, true);
        }
        catch (e) {
        }
    },
    
    /**
     * ファイルサイズを "," で区切る
     *
     * @param  Number size
     *         ファイルサイズ
     * @return String
     *         "," で区切られたファイルサイズ
     */
    getReadableSize : function (size) {
        var readableSize = "" + size;
        
        if (readableSize.length > 3) {
            readableSize
                = UnMHT.getReadableSize (readableSize
                                         .substr (0, readableSize.length - 3))
                + "," + readableSize.substr (readableSize.length - 3);
        }
        
        return readableSize;
    },
    
    /**
     * 時刻を可読形式に変換する
     *
     * @param  Number time
     *         時刻
     * @return String
     *         時刻の可読形式
     */
    getReadableTime : function (time) {
        time = new Date (time);
        var n = 0;
        var timeString = (time.getYear () + 1900) + "/";
        n = time.getMonth () + 1;
        if (n < 10) {
            timeString += "0";
        }
        timeString += n + "/";
        n = time.getDate ();
        if (n < 10) {
            timeString += "0";
        }
        timeString += n + " ";
        var weekDay = [
            UnMHT.messages.GetStringFromName ("weekday_sun"),
            UnMHT.messages.GetStringFromName ("weekday_mon"),
            UnMHT.messages.GetStringFromName ("weekday_tue"),
            UnMHT.messages.GetStringFromName ("weekday_wed"),
            UnMHT.messages.GetStringFromName ("weekday_thu"),
            UnMHT.messages.GetStringFromName ("weekday_fri"),
            UnMHT.messages.GetStringFromName ("weekday_sat")
            ];
        timeString += "(" + weekDay [time.getDay ()] + ") ";
        
        n = time.getHours ();
        if (n < 10) {
            timeString += "0";
        }
        timeString += n + ":";
        n = time.getMinutes ();
        if (n < 10) {
            timeString += "0";
        }
        timeString += n + ":";
        n = time.getSeconds ();
        if (n < 10) {
            timeString += "0";
        }
        timeString += n + ".";
        n = time.getMilliseconds ();
        if (n < 100) {
            timeString += "0";
        }
        if (n < 10) {
            timeString += "0";
        }
        timeString += n;
        
        return timeString;
    },
    
    /**
     * キャッシュページのヘッダを返す
     *
     * @param  Number entry
     *         キャッシュエントリ数
     * @param  Number size
     *         キャッシュサイズ
     * @return String
     *         キャッシュページのヘッダ
     */
    getCacheHead : function (entry, size) {
        var head;
        
        var readableSize
        = UnMHT.getReadableSize (size);
        
        head
        = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>"
        + "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\""
        + "          \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">"
        + "<html xmlns=\"http://www.w3.org/1999/xhtml\">"
        + "<head>"
        + "<title>"
        + UnMHT.messages.GetStringFromName ("cache_title")
        + "</title>"
        + "<style type=\"text/css\">"
        + "th {"
        + "text-align: right;"
        + "white-space: nowrap;"
        + "}"
        + "table {"
        + "margin-bottom: 1em;"
        + "}"
        + "table.file {"
        + "margin-bottom: 1em;"
        + "margin-left: 1em;"
        + "}"
        + "</style>"
        + "</head>"
        + "<body>"
        + "<h1>"
        + UnMHT.messages.GetStringFromName ("cache_title")
        + "</h1>"
        
        + "<hr />"
        + "<table border=\"0\">"
        
        + "<tr>"
        + "<th>"
        + UnMHT.messages.GetStringFromName ("cache_entry") + " "
        + "</th>"
        + "<td>"
        + entry
        + "</td>"
        + "</tr>"
        
        + "<tr>"
        + "<th>"
        + UnMHT.messages.GetStringFromName ("cache_size") + " "
        + "</th>"
        + "<td>"
        + readableSize + " "
        + UnMHT.messages.GetStringFromName ("bytes")
        + "</td>"
        + "</tr>"
        
        + "</table>"
        + "<hr />";
        
        return UnMHTConverter.convertFromUnicode (head, "utf-8");
    },
    
    /**
     * キャッシュページのフッタを返す
     *
     * @return String
     *         キャッシュページフッタ
     */
    getCacheFoot : function () {
        var foot;
        
        foot
        = "</body>"
        + "</html>";
        
        return UnMHTConverter.convertFromUnicode (foot, "utf-8");
    },
    
    /**
     * エラーページを返す
     *
     * @param  String location
     *         ファイルの場所
     * @return String
     *         エラーページ
     */
    getErrorPage : function (location) {
        var error;
        
        error
        = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>"
        + "<!DOCTYPE html PUBLIC \"-//W3C//DTD XHTML 1.0 Strict//EN\""
        + "          \"http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd\">"
        + "<html xmlns=\"http://www.w3.org/1999/xhtml\">"
        + "<head>"
        + "<title>"
        + UnMHT.messages.GetStringFromName ("error_title")
        + "</title>"
        + "<style type=\"text/css\">"
        + "h1 {"
        + "color: #ff0000;"
        + "background-color: inherit;"
        + "}"
        + "div.message {"
        + "font-size: 1em;"
        + "color: #ff0000;"
        + "background-color: inherit;"
        + "}"
        + "</style>"
        + "</head>"
        + "<body>"
        + "<h1>"
        + UnMHT.messages.GetStringFromName ("error_title")
        + "</h1>"
        
        + "<hr />"
        
        + "<div class=\"message\">"
        + UnMHT.messages.GetStringFromName ("error_file_not_found")
        + "<br>"
        + location
        + "</div>"
        
        + "<hr />"
        
        + "</body>"
        + "</html>";
        
        return UnMHTConverter.convertFromUnicode (error, "utf-8");
    },
    
    /**
     * キャッシュ情報を返す
     *
     * @return String
     *         キャッシュ情報の HTML 断片
     */
    getCacheInfo : function () {
        var i, j;
        var s = "";
        var size = 0;
        var extractor;
        
        var urispec;
        var extractors = new Array ();
        
        for (urispec in UnMHT.extractors) {
            extractors.push (UnMHT.extractors [urispec]);
        }
        
        extractors.sort (function (x, y) {
                return y.lastAccessTime - x.lastAccessTime;
            });
        
        for (i = 0; i < extractors.length; i ++) {
            if (i > 0) {
                s += "<hr />";
            }
            extractor = extractors [i];
            size += extractor.size;
            
            var original;
            
            if (UnMHT.protocolHandler.isUnMHTURI (extractor.rootURI)) {
                var param
                    = UnMHT.protocolHandler.getUnMHTURIParam
                    (extractor.rootURI);
                original = param.original;
                
                if (param.protocol == "file") {
                    original
                        = UnMHTFileManager.getFilenameFromURLSpec (original);
                }
            }
            else {
                original = "?";
            }
            
            var openedString = UnMHT.getReadableTime (extractor.extractTime);
            var lastAccessString
                = UnMHT.getReadableTime (extractor.lastAccessTime);
            
            var count = "";
            
            count
                = extractor.count + "/" +  extractor.files.length;
            
            s += "<table border=\"0\">"
                + "<tr>"
                + "<th>"
                + "URI: "
                + "</th>"
                + "<td>"
                + "<a href=\"" + extractor.rootURI + "\">"
                + UnMHTConverter.escapeEntity (extractor.rootURI) + "</a>"
                + "</td>"
                + "</tr>"
                
                + "<tr>"
                + "<th>"
                + UnMHT.messages.GetStringFromName ("original_uri") + " "
                + "</th>"
                + "<td>"
                + UnMHTConverter.escapeEntity (original)
                + "</td>"
                + "</tr>"
                
                + "<tr>"
                + "<th>"
                + UnMHT.messages.GetStringFromName ("opened_time") + " "
                + "</th>"
                + "<td>"
                + UnMHTConverter.escapeEntity (openedString)
                + "</td>"
                + "</tr>"
                
                + "<tr>"
                + "<th>"
                + UnMHT.messages.GetStringFromName ("last_access_time") + " "
                + "</th>"
                + "<td>"
                + UnMHTConverter.escapeEntity (lastAccessString)
                + "</td>"
                + "</tr>"
                
                + "<tr>"
                + "<th>"
                + UnMHT.messages.GetStringFromName ("file_count") + " "
                + "</th>"
                + "<td>"
                + UnMHTConverter.escapeEntity (count)
                + "</td>"
                + "</tr>";
                
            if (extractor.date) {
                var d = null;
                try {
                    d = new Date (extractor.date);
                }
                catch (e) {
                    d = null;
                }
                
                if (d) {
                    var t = d.getTime ();
                    var savedString;
                    if (t) {
                        savedString = UnMHT.getReadableTime (t);
                    }
                    else {
                        /* 未対応のフォーマット */
                        savedString = extractor.date;
                    }
            
                    s += "<tr>"
                        + "<th>"
                        + UnMHT.messages.GetStringFromName ("saved_time") + " "
                        + "</th>"
                        + "<td>"
                        + UnMHTConverter.escapeEntity (savedString)
                        + "</td>"
                        + "</tr>";
                }
            }
            
            if (extractor.subject) {
                s += "<tr>"
                    + "<th>"
                    + "Subject: "
                    + "</th>"
                    + "<td>"
                    + UnMHTConverter.escapeEntity (extractor.subject)
                    + "</td>"
                    + "</tr>";
            }
            
            s += "</table>";
            
            for (var j = 0; j < extractor.files.length; j ++) {
                var file = extractor.files [j];
                
                var refName = "";
                
                if (!file.deleted) {
                    refName
                        = "<a href=\"" + extractor.rootURI + file.refName
                        + "\">"
                        + UnMHTConverter.escapeEntity (file.refName)
                        + "</a>";
                }
                else {
                    refName = UnMHTConverter.escapeEntity (file.refName);
                }
                
                var isRoot = "";
                
                if (extractor.rootFile == file) {
                    isRoot = " ("
                        + UnMHT.messages.GetStringFromName ("root_document")
                        + ")";
                }
                
                var deleted = "";
                if (file.deleted) {
                    deleted = " style=\"color: #808080;\"";
                }
                
                var charset = "";
                
                if (file.filetype.match (/^text\//)
                    && file.charset) {
                    charset = "charset=" + file.charset + "; ";
                }
                
                s += "<table border=\"0\" class=\"file\"" + deleted +">"
                    
                    + "<tr>"
                    + "<th>"
                    + UnMHT.messages.GetStringFromName ("ref_name") + " "
                    + "</th>"
                    + "<td>"
                    + refName + isRoot
                    + "</td>"
                    + "</tr>";
                
                if (file.contentLocation) {
                    var location = file.contentLocation;
                    location
                        = location
                        .replace (/^unmht:\/\/\/dummy\.([0-9]+)\//,
                                  function (matched, sep) {
                                      var sep1 = (sep & 1) ? "//" : "";
                                      var sep2 = (sep & 2) ? "//" : "";
                                      var sep3 = (sep & 4) ? "/" : "";
                                      return "file:" + sep1 + sep2 + sep3;
                                  })
                        .replace (/^unmht:\/\/\/cid\.0\//, "cid:");
                    s += "<tr>"
                        + "<th>"
                        + "Content-Location: "
                        + "</th>"
                        + "<td>"
                        + UnMHTConverter.escapeEntity (location)
                        + "</td>"
                        + "</tr>";
                    s += "<tr>"
                        + "<th>"
                        + "leafName: "
                        + "</th>"
                        + "<td>"
                        + UnMHTConverter.escapeEntity (file.leafName)
                        + "</td>"
                        + "</tr>";
                }
                if (file.contentBase) {
                    var location = file.contentBase;
                    location
                        = location
                        .replace (/^unmht:\/\/\/dummy\.([0-9]+)\//,
                                  function (matched, sep) {
                                      var sep1 = (sep & 1) ? "//" : "";
                                      var sep2 = (sep & 2) ? "//" : "";
                                      var sep3 = (sep & 4) ? "/" : "";
                                      return "file:" + sep1 + sep2 + sep3;
                                  })
                        .replace (/^unmht:\/\/\/cid\.0\//, "cid:");
                    s += "<tr>"
                        + "<th>"
                        + "Content-Base: "
                        + "</th>"
                        + "<td>"
                        + UnMHTConverter.escapeEntity (location)
                        + "</td>"
                        + "</tr>";
                }
                if (file.cid) {
                    s += "<tr>"
                        + "<th>"
                        + "Content-ID: "
                        + "</th>"
                        + "<td>"
                        + UnMHTConverter.escapeEntity (file.cid)
                        + "</td>"
                        + "</tr>";
                }
                
                if (file.disposition) {
                    s += "<tr>"
                        + "<th>"
                        + "Content-Disposition: "
                        + "</th>"
                        + "<td>"
                        + UnMHTConverter.escapeEntity (file.dispositionType)
                        + "; filename="
                        + UnMHTConverter.escapeEntity (file.disposition)
                        + "</td>"
                        + "</tr>";
                }
                
                s += "<tr>"
                    + "<th>"
                    + "Content-Type: "
                    + "</th>"
                    + "<td>"
                    + UnMHTConverter.escapeEntity (charset + file.filetype)
                    + "</td>"
                    + "</tr>";
                
                if (!file.deleted) {
                    var encoding = "";
                    
                    if (file.encoding == 1) {
                        encoding = "quoted-printable";
                    }
                    else if (file.encoding == 2) {
                        encoding = "base64";
                    }
                    else if (file.encoding == 3) {
                        encoding = "7bit";
                    }
                    else {
                        encoding = "8bit";
                    }
 
                    var readableSize
                        = UnMHT.getReadableSize (file.size);
                    
                    s += "<tr>"
                        + "<th>"
                        + "Content-Encoding: "
                        + "</th>"
                        + "<td>"
                        + UnMHTConverter.escapeEntity (encoding)
                        + "</td>"
                        + "</tr>";
                    
                    if (!UnMHT.enableMemoryCache) {
                        s += "<tr>"
                            + "<th>"
                            + UnMHT.messages.GetStringFromName
                            ("native_filaname") + " "
                            + "</th>"
                            + "<td>"
                            + UnMHTConverter.escapeEntity (file.nativeFilename)
                            + "</td>"
                            + "</tr>";
                    }
                    
                    s += "<tr>"
                        + "<th>"
                        + UnMHT.messages.GetStringFromName ("file_size") + " "
                        + "</th>"
                        + "<td>"
                        + readableSize + " "
                        + UnMHT.messages.GetStringFromName ("bytes")
                        + "</td>"
                        + "</tr>";
                }
                else {
                    s += "<tr>"
                        + "<th>"
                        + UnMHT.messages.GetStringFromName ("not_extracted")
                        + "</th>"
                        + "<td>"
                        + " "
                        + "</td>"
                        + "</tr>";
                }
                
                s += "</table>";
            }
        }
        
        return [UnMHTConverter.convertFromUnicode (s, "utf-8"),
                size, i];
    },
    
    /**
     * mht から展開したファイルの URI を取得する
     * 他の拡張から呼び出される
     *
     * @param  nsIURI contentLocation
     *         対象の URI
     * @param  nsIURI requestOrigin
     *         呼び出し元の URI
     *         アドレスに UnMHT と入っているもの
     * @return nsIURI
     *         展開したファイルの URI
     *         存在しなかった場合は null
     */
    getMHTFileURI : function (contentLocation, requestOrigin) {
        if (!UnMHT.protocolHandler.isUnMHTURI (requestOrigin.spec)) {
            return null;
        }
        
        var param
        = UnMHT.protocolHandler.getUnMHTURIParam (requestOrigin.spec);
        var original = param.original;
        var refName = param.refName;
        
        var extractor = null;
        var file = null;
        if (original
            && original in UnMHT.extractors) {
            extractor = UnMHT.extractors [original];
            if (refName
                && refName in extractor.refFiles) {
                file = extractor.refFiles [refName];
            }
            else {
                file = extractor.rootFile;
            }
        }
        
        if (file) {
            var list
            = UnMHT.checkFile (extractor, file, contentLocation.spec, false);
            
            if (list [0] != -1) {
                /* ファイルが MHT に含まれた場合 */
                if (list [1]) {
                    /* 展開した場合 */
                    var uri
                        = Components
                        .classes ["@mozilla.org/network/standard-url;1"]
                        .createInstance (Components.interfaces.nsIURI);
                    uri.spec = param.rootURI + list [1].refName + list [2];
                    return uri;
                }
            }
        }
        
        return null;
    }, 
    
    /* Opera/IE/Safari 版, QuickLook 版に移植する部分 (3) ---- ここから ---- */
    /**
     * mht に含まれるファイルを探す
     *
     * @param  UnMHTExtractor extractor
     *         ファイルの展開部分
     * @param  UnMHTExtractorFile file
     *         呼び出し元のファイル
     * @param  String path
     *         対象のパス
     * @param  Boolean referred
     *         referredBaseDir をチェックするか
     * @return Array
     *         [Number ファイルのインデックス, UnMHTExtractorFile 対象のファイル,
     *          String アンカー文字列]
     *         見付からなければインデックスが -1
     *         見付かっても削除されていればファイルが null
     */
    checkFile : function (extractor, file, path, referred) {
        var jointedPath = UnMHTFileManager.jointPath (file.baseDir, path);
        var jointedPath2 = "";
        var jointedPath3 = "";
        var jointedPath4 = "";
        if (referred && file.referredBaseDir != "") {
            /* HTML ファイルから参照されたものの場合 */
            
            /* 参照元のファイルからの相対パスとみなす */
            jointedPath2
                = UnMHTFileManager.jointPath (file.referredBaseDir, path);
        }
        else {
            jointedPath2 = "";
        }
        
        var i, file2, filename;
        
        var refName = "";
        
        var anchor = "";
        if (path.match (/^([^#]*)(#.+)$/)) {
            path = RegExp.$1;
            anchor = RegExp.$2;
        }
        
        if (anchor && path == "") {
            /* 同じファイル */
            for (i = 0; i < extractor.files.length; i ++) {
                if (file == extractor.files [i]) {
                    if (file.deleted) {
                        return [i, null, anchor];
                    }
                    
                    return [i, file, anchor];
                }
            }
        }
        
        if (UnMHT.mode == 1
            && UnMHT.protocolHandler.isUnMHTURI (path)) {
            var param = UnMHT.protocolHandler.getUnMHTURIParam (path);
            
            var original = param.original; 
            var refName = param.refName;
            if (refName == "") {
                refName = "index.html";
            }
            
            if (original == extractor.original) {
                for (i = 0; i < extractor.files.length; i ++) {
                    file2 = extractor.files [i];
                    if (file2.refName == refName) {
                        if (file2.deleted) {
                            return [i, null, anchor];
                        }
                    
                        return [i, file2, anchor];
                    }
                }
            }
            
            var absPath = "/" + param.path;
            jointedPath3 = UnMHTFileManager.jointPath (file.baseDir, absPath);
            if (referred && file.referredBaseDir != "") {
                /* HTML ファイルから参照されたものの場合 */
            
                /* 参照元のファイルからの相対パスとみなす */
                jointedPath4
                    = UnMHTFileManager.jointPath (file.referredBaseDir,
                                                  absPath);
            }
            else {
                jointedPath4 = "";
            }
        }
        
        /* URI に対応するファイルが存在する場合 */
        for (i = 0; i < extractor.files.length; i ++) {
            file2 = extractor.files [i];
            
            filename = file2.location;
            if (filename) {
                if (path == filename
                    || jointedPath == filename
                    || (referred && jointedPath2 == filename)
                    || jointedPath3 == filename
                    || (referred && jointedPath4 == filename)) {
                    if (file2.deleted) {
                        return [i, null, anchor];
                    }
                    
                    return [i, file2, anchor];
                }
            }
        }
        
        /* ファイル名のみ対応するファイルが存在する場合 */
        for (i = 0; i < extractor.files.length; i ++) {
            file2 = extractor.files [i];
            
            filename = file2.leafName;
            if (filename) {
                if (path.length >= filename.length &&
                    path.substr (path.length - filename.length,
                                 filename.length) == filename) {
                    if (file2.deleted) {
                        return [i, null, anchor];
                    }
                    
                    return [i, file2, anchor];
                }
            }
        }
        
        /* 変換済みの Content-ID の場合 */
        cid = "";
        if (UnMHT.mode == 1) {
            if (UnMHT.protocolHandler.isUnMHTURI (path)) {
                var param = UnMHT.protocolHandler.getUnMHTURIParam (path);
                if (param.protocol == "cid") {
                    cid = param.refName;
                }
            }
        }
        else if (UnMHT.mode == 2) {
            if (path.match (/^data:text\/plain,cid:(.+)$/)) {
                cid = RegExp.$1;
            }
        }
        
        if (cid) {
            for (i = 0; i < extractor.files.length; i ++) {
                file2 = extractor.files [i];
                if (cid == file2.cid) {
                    if (file2.deleted) {
                        return [i, null, anchor];
                    }
                    
                    return [i, file2, anchor];
                }
            }
        }
        
        if (UnMHT.mode == 1) {
            var path2 = path;
            try {
                if (UnMHT.protocolHandler.isUnMHTURI (path)) {
                    var param = UnMHT.protocolHandler.getUnMHTURIParam (path);
                    if (param.protocol == "dummy") {
                        path2 = param.original
                            .replace (/^dummy:/, "file:");
                    }
                }
                path2 = unescape (path2);
                path2 = UnMHTConverter.convertToUnicode (path2, "UTF-8");
            }
            catch (e) {
            }
            
            if (path2 != path) {
                return UnMHT.checkFile (extractor, file, path2, referred);
            }
        }
        
        return [-1, "", ""];
    },
    /* Opera/IE/Safari 版, QuickLook 版に移植する部分 (3) ---- ここまで ---- */
    
    /**
     * 展開したファイルの情報を取得する
     *
     * @param  nsIURI uri
     *         unmht: 形式のファイルの URI
     * @return UnMHTExtractorFile
     *         ファイルの情報
     *         見付からなかった場合は null
     */
    getFile : function (uri) {
        if (!UnMHT.protocolHandler.isUnMHTURI (uri.spec)) {
            return null;
        }
        
        var param
        = UnMHT.protocolHandler.getUnMHTURIParam (uri.spec);
        var original = param.original;
        var refName = param.refName;
        
        var extractor = null;
        var file = null;
        if (original
            && original in UnMHT.extractors) {
            extractor = UnMHT.extractors [original];
            extractor.lastAccessTime = (new Date ()).getTime ();
            if (refName
                && refName in extractor.refFiles) {
                file = extractor.refFiles [refName];
            }
            else {
                file = extractor.rootFile;
            }
        }
        
        return file;
    },
    
    /**
     * mht 内のファイル名を置き換える
     *
     * @param  nsIURI contentLocation
     *         対象の URI
     * @param  nsIURI requestOrigin
     *         呼び出し元の URI
     *         アドレスに UnMHT と入っているもの
     * @param  HTMLElement context
     *         呼び出し元
     * @return Boolean
     *         許可するかどうか
     */
    replaceLocation : function (contentLocation, requestOrigin, context) {
        if (context == null) {
            /* 古い Mozilla Suite でのアンカーによる移動の場合、許可する */
            return true;
        }
        
        if (context instanceof XULElement) {
            /* アンカーによる移動の場合、許可する */
            return true;
        }
        
        if (context instanceof HTMLLinkElement) {
            /* link による参照の場合、 先にやっているので許可する */
            return true;
        }
        if (context instanceof HTMLScriptElement) {
            /* script による参照の場合、 先にやっているので許可する */
            return true;
        }
        
        if (context instanceof HTMLDocument
            || context instanceof HTMLStyleElement) {
            /* CSS からの参照の場合 */
            if (UnMHT.enableFastExtract) {
                /* CSS を無視する場合、拒否する */
                return false;
            }
            else {
                /* それ以外の場合、許可する */
                return true;
            }
        }
        
        if (context.getAttribute ("__unmht_modified") == "1") {
            /* setTimeout の修正からの読み込みの場合、許可する */
            return true;
        }
        
        /* 対応する展開のチェック */
        if (UnMHT.protocolHandler.isUnMHTURI (requestOrigin.spec)) {
            var param
            = UnMHT.protocolHandler.getUnMHTURIParam (requestOrigin.spec);
            var original = param.original;
            var refName = param.refName;
            
            var extractor = null;
            if (original in UnMHT.extractors) {
                /* 対応する展開があった場合 */
                extractor = UnMHT.extractors [original];
                var attribute = "src";
                
                if (refName
                    && refName in extractor.refFiles) {
                    file = extractor.refFiles [refName];
                }
                else {
                    file = extractor.rootFile;
                }
            
                var spec = contentLocation.spec;
                
                var list
                    = UnMHT.checkFile (extractor, file, spec, false);
                
                if (list [0] != -1) {
                    /* ファイルが MHT に含まれた場合 */
                    if (list [1]) {
                        /* 展開した場合、置き換える */
                        var newpath
                            = extractor.rootURI + list [1].refName + list [2];
                        if (context instanceof HTMLEmbedElement) {
                            context.ownerDocument.defaultView.setTimeout
                                (function (node, attr, name) {
                                    var newNode = node.cloneNode (true);
                                
                                    newNode.setAttribute ("__unmht_modified", "1");
                                    var tmp = "__unmht_" + attribute;
                                    var value = newNode.getAttribute (attr);
                                    if (!newNode.hasAttribute (tmp)) {
                                        newNode.setAttribute (tmp, value);
                                    }
                                    newNode.setAttribute (attr, name);
                                
                                    var parentNode = node.parentNode;
                                    var nextSibling = node.nextSibling;
                                
                                    parentNode.removeChild (node);
                                
                                    if (nextSibling) {
                                        parentNode.insertBefore
                                            (newNode, nextSibling);
                                    }
                                    else {
                                        parentNode.appendChild
                                            (newNode);
                                    }
                                }, 100, context, attribute, newpath);
                            return false;
                        }
                        else {
                            if (!UnMHT.isOld) {
                                context.setAttribute ("__unmht_modified", "1");
                                context.setAttribute ("__unmht_" + attribute,
                                                      context.getAttribute
                                                      (attribute));
                                context.setAttribute (attribute, newpath);
                            }
                            context.ownerDocument.defaultView.setTimeout
                                (function (node, attr, name) {
                                    node.setAttribute ("__unmht_modified", "1");
                                    var tmp = "__unmht_" + attribute;
                                    var value = node.getAttribute (attr);
                                    if (!node.hasAttribute (tmp)) {
                                        node.setAttribute (tmp, value);
                                    }
                                    node.setAttribute (attr, name);
                                }, 100, context, attribute, newpath);
                            return false;
                        }
                    }
                    else {
                        /* 展開しなかった場合、削除する */
                        if (!UnMHT.isOld) {
                            context.removeAttribute (attribute);
                        }
                        context.ownerDocument.defaultView.setTimeout
                            (function (node, attr) {
                                try {
                                    context.removeAttribute (attr);
                                }
                                catch (e) {
                                }
                            }, 100, context, attribute);
                        return false;
                    }
                }
                
                /* 対応するものが見付からなかった場合 */
            
                if (spec.match (/^unmht:\/\/\/dummy\./)
                    || spec.match (/^file:\/\//)) {
                    /* 参照先はローカルファイルのなので拒否する  */
                    if (!UnMHT.isOld) {
                        context.removeAttribute (attribute);
                    }
                    context.ownerDocument.defaultView.setTimeout
                        (function (node, attr) {
                            try {
                                context.removeAttribute (attr);
                            }
                            catch (e) {
                            }
                        }, 100, context, attribute);
                    return false;
                }
            
                if (spec.indexOf (requestOrigin.spec) == 0) {
                    /* unmht のパスからの相対になっている */
                    var newpath;
                    var sub = spec.substr (requestOrigin.spec.length);
                    if (sub
                        && sub.match (/^\?/)) {
                        /* 元のアドレスにクエリ文字列を追加しただけ */
                        newpath
                            = file.location.replace (/\?.*$/, "") + sub;
                        contentLocation.spec = newpath;
                    
                        return UnMHT.replaceLocation (contentLocation,
                                                      requestOrigin, context);
                    }
                    else {
                        newpath
                            = UnMHTFileManager.jointPath (file.baseDir, sub);
                    }
                
                    if (context instanceof HTMLEmbedElement) {
                        context.ownerDocument.defaultView.setTimeout
                            (function (node, attr, name) {
                                var newNode = node.cloneNode (true);
                            
                                newNode.setAttribute ("__unmht_modified", "1");
                                var tmp = "__unmht_" + attribute;
                                var value = newNode.getAttribute (attr);
                                if (!newNode.hasAttribute (tmp)) {
                                    newNode.setAttribute (tmp, value);
                                }
                                newNode.setAttribute (attr, name);
                                
                                var parentNode = node.parentNode;
                                var nextSibling = node.nextSibling;
                                
                                parentNode.removeChild (node);
                                
                                if (nextSibling) {
                                    parentNode.insertBefore
                                        (newNode, nextSibling);
                                }
                                else {
                                    parentNode.appendChild
                                        (newNode);
                                }
                            }, 100, context, attribute, newpath);
                        return false;
                    }
                    else {
                        if (!UnMHT.isOld) {
                            context.setAttribute ("__unmht_modified", "1");
                            context.setAttribute ("__unmht_" + attribute,
                                                  context.getAttribute
                                                  (attribute));
                            context.setAttribute (attribute, newpath);
                        }
                        context.ownerDocument.defaultView.setTimeout
                            (function (node, attr, name) {
                                node.setAttribute ("__unmht_modified", "1");
                                var tmp = "__unmht_" + attribute;
                                var value = node.getAttribute (attr);
                                if (!node.hasAttribute (tmp)) {
                                    node.setAttribute (tmp, value);
                                }
                                node.setAttribute (attr, name);
                            }, 100, context, attribute, newpath);
                        return false;
                    }
                }
            }
        }
        
        return true;
    },
    
    /**
     * 展開先のディレクトリの名前を作成する
     *
     * @return String
     *         展開先のディレクトリの名前
     */
    createExtractName : function () {
        return new Date ().getTime () + "_"
        + Math.floor (Math.random () * 1000);
    },
    
    /**
     * mht ファイルを展開して開く
     *
     * @param  nsIURI uri
     *         開く URI
     * @param  Window targetWindow
     *         対象のウィンドウ
     * @param  Boolean hasDocument
     *         ドキュメントに内容を持っているか
     * @param  Boolean replace
     *         履歴を置き換えるかどうか
     * @param  Number extract
     *         展開するか
     *           0: 設定にまかせる
     *           1: 展開する
     *           2: 展開しない
     * @param  String refName
     *         対象のファイル
     * @param  Boolean useCache
     *         キャッシュを使用するか
     */
    loadMHT : function (uri, targetWindow,
                        hasDocument, replace, extract, refName,
                        useCache) {
        if (Components.interfaces.nsIPrefBranch2 == undefined) {
            /* 監視していない場合にのみ設定を取得する */
            UnMHTConfigManager.getConfigurationFromPreferencesAll ();
            UnMHTConfigManager.getConfigurationFromPreferences ();
        }
        
        if (extract == 0) {
            extract = UnMHT.enableAll;
        }
        else if (extract == 1) {
            extract = true;
        }
        else if (extract == 2) {
            extract = false;
        }
        
        if (uri.scheme == "file") {
            /* file プロトコルの場合、そのファイルから開く */
            var filename = UnMHTFileManager.getFilenameFromURLSpec (uri.spec);
            UnMHT.loadMHTFromFile (uri, targetWindow,
                                   hasDocument,
                                   replace,
                                   extract,
                                   refName,
                                   filename, "");
        }
        else {
            /* それ以外の場合、ウェブから開く */
            UnMHT.loadMHTFromWeb (uri, targetWindow,
                                  hasDocument,
                                  replace,
                                  extract,
                                  refName,
                                  useCache);
        }
    },
    
    /**
     * ファイルから mht ファイルを展開して開く
     *
     * @param  nsIURI uri
     *         開く URI (本来の URI)
     * @param  Window targetWindow
     *         対象のウィンドウ
     * @param  Boolean hasDocument
     *         ドキュメントに内容を持っているか
     * @param  Boolean replace
     *         履歴を置き換えるかどうか
     * @param  Boolean extract
     *         展開するか
     * @param  String filename
     *         開くファイル名 (一旦キャッシュに保存したものの場合もある)
     * @param  String extractName
     *         展開するディレクトリ
     * @param  String refName
     *         対象のファイル
     */
    loadMHTFromFile : function (uri, targetWindow,
                                hasDocument, replace, extract, refName,
                                filename, extractName) {
        var text = UnMHTFileManager.readFile (filename);
        if (text == "") {
            if (hasDocument) {
                UnMHT.loadMHTFromDocument (uri, targetWindow,
                                           true,
                                           replace,
                                           extract,
                                           refName);
            }
            else {
                UnMHT.showErrorPage (targetWindow, uri.spec);
            }
            return;
        }
        
        var extractor = new UnMHTExtractor ();
        var urlspec
        = extractor.extractMHT (uri.spec, text, false, extractName, extract);
        if (urlspec) {
            if (!UnMHT.enableMemoryCache
                && extractor.original in UnMHT.extractors) {
                var dir, dirname;
                dirname = UnMHTFileManager.cacheDirectory
                    + UnMHTFileManager.separator
                    + UnMHT.extractors [extractor.original].extractName;
                dir = UnMHTFileManager.initFile (dirname);
                if (dir && dir.exists ()) {
                    dir.remove (true);
                }
            }
            
            UnMHT.extractors [extractor.original] = extractor;
            
            var nav
                = targetWindow
                .QueryInterface (Components.interfaces.nsIInterfaceRequestor)
                .getInterface (Components.interfaces.nsIWebNavigation);
            
            var flag = 0;
            if (replace) {
                flag = nav.LOAD_FLAGS_REPLACE_HISTORY;
            }
            
            if (refName
                && refName in extractor.refFiles) {
                urlspec += refName;
            }
            
            nav.loadURI (urlspec,
                         flag, null, null, null);
        }
    },
    
    /**
     * ドキュメントから mht ファイルを展開して開く
     *
     * @param  nsIURI uri
     *         開く URI
     * @param  Window targetWindow
     *         対象のウィンドウ
     * @param  Boolean hasDocument
     *         ドキュメントに内容を持っているか
     * @param  Boolean replace
     *         履歴を置き換えるかどうか
     * @param  Boolean extract
     *         展開するか
     * @param  String refName
     *         対象のファイル
     */
    loadMHTFromDocument : function (uri, targetWindow,
                                    hasDocument, replace, extract, refName) {
        var text = "";
        var nodes = targetWindow.document.getElementsByTagName ("pre");
        for (var i = 0; i < nodes.length; i ++) {
            var node = nodes [i].firstChild;
            while (node) {
                text += node.nodeValue;
                node = node.nextSibling;
            }
        }
        
        if (text == "") {
            UnMHT.showErrorPage (targetWindow, uri.spec);
            return;
        }
        
        var extractor = new UnMHTExtractor ();
        var urlspec
        = extractor.extractMHT (targetWindow.document.location.href,
                                text, true, "", extract);
        
        if (urlspec) {
            if (!UnMHT.enableMemoryCache
                && extractor.original in UnMHT.extractors) {
                var dir, dirname;
                dirname = UnMHTFileManager.cacheDirectory
                    + UnMHTFileManager.separator
                    + UnMHT.extractors [extractor.original].extractName;
                dir = UnMHTFileManager.initFile (dirname);
                if (dir && dir.exists ()) {
                    dir.remove (true);
                }
            }
            
            UnMHT.extractors [extractor.original] = extractor;
            
            var nav
                = targetWindow
                .QueryInterface (Components.interfaces.nsIInterfaceRequestor)
                .getInterface (Components.interfaces.nsIWebNavigation);
            
            var flag = 0;
            if (replace) {
                flag = nav.LOAD_FLAGS_REPLACE_HISTORY;
            }
            
            if (refName
                && refName in extractor.refFiles) {
                urlspec += refName;
            }
            
            nav.loadURI (urlspec,
                         flag, null, null, null);
        }
    },
    
    /**
     * ウェブのファイルから mht ファイルを展開して開く
     *
     * @param  nsIURI uri
     *         開く URI
     * @param  Window targetWindow
     *         対象のウィンドウ
     * @param  Boolean hasDocument
     *         ドキュメントに内容を持っているか
     * @param  Boolean replace
     *         履歴を置き換えるかどうか
     * @param  Boolean extract
     *         展開するか
     * @param  String refName
     *         対象のファイル
     * @param  Boolean useCache
     *         キャッシュを使用するか
     */
    loadMHTFromWeb : function (uri, targetWindow,
                               hasDocument, replace, extract, refName,
                               useCache) {
        var extractName = "";
        if (UnMHT.enableMemoryCache) {
            var leafName 
            = new Date ().getTime () + "_"
            + Math.floor (Math.random () * 1000);
            var filename
            = UnMHTFileManager.cacheDirectory
            + UnMHTFileManager.separator + leafName;
        }
        else {
            /* 展開するディレクトリを作成する */
            extractName = UnMHT.createExtractName ();
            var extractDirectory
            = UnMHTFileManager.cacheDirectory
            + UnMHTFileManager.separator + extractName;
            UnMHTFileManager.createDirectory (extractDirectory);
            
            var filename = extractDirectory
            + UnMHTFileManager.separator + "cache";
        }
        
        var targetFile = UnMHTFileManager.initFile (filename);
        
        var listener = new UnMHTProgressListener ();
        
        listener.uri = uri;
        listener.targetWindow = targetWindow;
        
        listener.hasDocument = hasDocument;
        listener.replace = replace;
        listener.extract = extract;
        listener.refName = refName;
        
        listener.filename = filename;
        listener.extractName = extractName;
        
        /* ファイルを保存する */
        var webBrowserPersist
        = Components
        .classes ["@mozilla.org/embedding/browser/nsWebBrowserPersist;1"]
        .createInstance (Components.interfaces.nsIWebBrowserPersist);
        if (useCache) {
            webBrowserPersist.persistFlags = 0;
        }
        else {
            webBrowserPersist.persistFlags
            = webBrowserPersist.PERSIST_FLAGS_BYPASS_CACHE;
        }
        webBrowserPersist.progressListener = listener;
        try {
            webBrowserPersist.saveURI (uri, null, targetFile);
        }
        catch (e) {
            try {
                webBrowserPersist.saveURI (uri, null, null, null, null,
                                           targetFile);
            }
            catch (e) {
                if (hasDocument) {
                    UnMHT.loadMHTFromDocument (uri, targetWindow,
                                               true,
                                               replace,
                                               extract,
                                               refName);
                }
                else {
                    UnMHT.showErrorPage (targetWindow, uri.spec);
                }
            }
        }
    },
    
    /**
     * フォーカスのあるウィンドウから mht ファイルを開く
     *
     * @param  Number extract
     *         展開するか
     *           0: 設定にまかせる
     *           1: 展開する
     *           2: 展開しない
     */
    loadMHTFromFocusedWindow : function (extract) {
        var targetWindow = document.commandDispatcher.focusedWindow;
        if (targetWindow == window) {
            targetWindow = content;
        }
        
        var uri
        = Components.classes ["@mozilla.org/network/standard-url;1"]
        .createInstance (Components.interfaces.nsIURI);
        uri.spec = targetWindow.document.location.href;
        
        if (UnMHT.protocolHandler.isUnMHTURI (uri.spec)) {
            uri.spec = UnMHT.protocolHandler.deUnMHTURI (uri.spec);
        }
        
        UnMHT.loadMHT (uri, targetWindow,
                       true,    /* 開いているドキュメントを使用する */
                       false,   /* 履歴はそのまま */
                       extract, /* 展開は引数次第 */
                       "",      /* ルートドキュメントを開く */
                       true);   /* キャッシュを使用する */
    },
    
    /**
     * エラーメッセージを表示する
     *
     * @param  Window targetWindow
     *         対象のウィンドウ
     * @param  String location
     *         ファイルの URI
     */
    showErrorPage : function (targetWindow, location) {
        var nav
        = targetWindow
        .QueryInterface (Components.interfaces.nsIInterfaceRequestor)
        .getInterface (Components.interfaces.nsIWebNavigation);
        
        location = UnMHT.protocolHandler.enUnMHTURI (location);
        location = location.replace (/^unmht:/, "error:");
        location = UnMHT.protocolHandler.enUnMHTURI (location);
        
        nav.loadURI (
            location,
            0, null, null, null);
    },
    
    /**
     * キャッシュを削除する
     *
     * @param  Number expire
     *         ミリ秒単位の経過時間
     *         0 なら即削除
     * @param  Boolean force
     *         強制削除
     */
    clearCache : function (expire, force) {
        if (!UnMHT.enableCacheExpire && !force) {
            return;
        }
        
        if (UnMHT.enableMemoryCache) {
            var now = new Date ().getTime ();

            for (var urispec in UnMHT.extractors) {
                var extractor = UnMHT.extractors [urispec];
            
                if (now < extractor.lastAccessTime + expire) {
                    /* 最終アクセスから指定時間経過していない */
                    continue;
                }
            
                UnMHT.extractors [urispec] = null;
                delete UnMHT.extractors [urispec];
            }
            
            if (expire == 0) {
                UnMHTFileManager.clearCacheDirectory (expire, false);
            }
        }
        else {
            UnMHTFileManager.clearCacheDirectory (expire, true);
        }
    }
};

/**
 * ブラウザのイベントリスナ
 */
var UnMHTBrowserProgressListener = {
    /**
     * インターフェースの要求
     *   nsISupports.QueryInterface
     *
     * @param  nsIIDRef iid
     *         インターフェース ID
     * @throws Components.results.NS_NOINTERFACE
     * @return nsIWebProgressListener
     *         this
     */
    QueryInterface : function (iid) {
        if (iid.equals (Components.interfaces.nsISupports)
            || iid.equals (Components.interfaces.nsISupportsWeakReference)
            || iid.equals (Components.interfaces.nsIWebProgressListener)) {
            return this;
        }
        
        throw Components.results.NS_NOINTERFACE;
    },
    
    /**
     * 監視ウィンドウのロケーションが変わった時のイベント
     *   nsIWebProgressListener.onLocationChange
     *
     * @param  nsIWebProgress webProgress
     *         呼び出し元
     * @param  nsIRequest request
     *         状況の変わったリクエスト
     * @param  String location
     *         ロケーション
     */
    onLocationChange : function (webProgress, request, location) {
        var panel;
        
        var targetDocument;
        var savable = true;
        
        if (!UnMHT.isThunderbird) {
            var tabbrowser = document.getElementById ("content");
            targetDocument = tabbrowser.contentDocument;
        }
        else {
            var messagepane = document.getElementById ("messagepane");
            targetDocument = messagepane.contentDocument;
            
            var messagepanebox = document.getElementById ("messagepanebox");
            if (messagepanebox.collapsed) {
                savable = false;
            }
        }
        
        if (savable && UnMHT.isSavable (targetDocument)) {
            panel
                = document.getElementById ("unmht-toolbarbutton-save");
            if (panel) {
                panel.setAttribute ("status", "enabled");
            }
            if (UnMHT.isThunderbird) {
                var command = document.getElementById ("unmht-command-save");
                if (command) {
                    command.setAttribute ("disabled", "false");
                }
            }
        }
        else {
            panel
                = document.getElementById ("unmht-toolbarbutton-save");
            if (panel) {
                panel.setAttribute ("status", "disabled");
            }
            if (UnMHT.isThunderbird) {
                var command = document.getElementById ("unmht-command-save");
                if (command) {
                    command.setAttribute ("disabled", "true");
                }
            }
        }
    },
    
    /**
     * 進行状況が変わった時のイベント
     *   nsIWebProgressListener.onProgressChange
     * 未使用
     */
    onProgressChange: function (webProgress , request,
                                curSelfProgress, maxSelfProgress,
                                curTotalProgress, maxTotalProgress) {
    },
    
    /**
     * プロトコルのセキュリティ設定が変わった時のイベント
     *   nsIWebProgressListener.onSecurityChange
     * 未使用
     */
    onSecurityChange : function (webProgress, request, state) {
    },
    
    /**
     * 状況が変わった時のイベント
     *   nsIWebProgressListener.onStateChange
     * 未使用
     */
    onStateChange : function (webProgress, request, stateFlags, status) {
    },
    
    /**
     * ステータスバーに表示するメッセージが変わった時のイベント
     *   nsIWebProgressListener.onStatusChange
     * 未使用
     */
    onStatusChange : function (webProgress, request, status, message) {
    }
};

/**
 * 設定管理
 *   Inherits From: nsIObserver
 */
var UnMHTConfigManager = {
    prefBranch : null,    /* nsIPrefBranch/nsIPrefBranch2  pref サービス */
    
    /**
     * 初期化処理
     */
    init : function () {
        UnMHTConfigManager.loadPrefBranch ();
        
        UnMHTConfigManager.prefBranch.setCharPref ("unmht.version",
                                                   UnMHTVersion);
        
        if (Components.interfaces.nsIPrefBranch2) {
            /* 設定を取得する */
            UnMHTConfigManager.getConfigurationFromPreferencesAll ();
            UnMHTConfigManager.getConfigurationFromPreferences ();
            
            /* ダイアログからの設定の変更を監視する */
            UnMHTConfigManager.prefBranch.addObserver ("unmht.savepref",
                                                       UnMHTConfigManager,
                                                       false);
        }
    },
    
    /**
     * prefBranch を設定し直す
     */
    loadPrefBranch : function () {
        if (Components.interfaces.nsIPrefBranch2) {
            UnMHTConfigManager.prefBranch
            = Components.classes ["@mozilla.org/preferences-service;1"]
            .getService (Components.interfaces.nsIPrefBranch2);
        }
        else {
            UnMHTConfigManager.prefBranch
            = Components.classes ["@mozilla.org/preferences-service;1"]
            .getService (Components.interfaces.nsIPrefBranch);
        }
    },
    
    /**
     * 終了処理
     */
    term : function () {
        if (Components.interfaces.nsIPrefBranch2) {
            /* 設定の変更の監視を解除する */
            UnMHTConfigManager.prefBranch.removeObserver ("unmht.savepref",
                                                          UnMHTConfigManager);
        }
    },
    
    /**
     * 設定を読み込む
     * 設定が無ければ既定値を書き込む
     *
     * @param  String type
     *         設定の種類
     *           "bool": bool
     *           "char": 文字列
     *           "int":  数値
     * @param  String name
     *         設定名
     * @param  Boolean/String/Number value
     *         既定値
     * @return Boolean/String/Number
     *         取得した値
     *         設定が無ければ既定値
     */
    initPref : function (type, name, value) {
        if (UnMHTConfigManager.prefBranch.prefHasUserValue (name)) {
            ; /* switch のインデント用 */
            switch (type) {
                case "bool":
                    value = UnMHTConfigManager.prefBranch.getBoolPref (name);
                    break;
                case "char":
                    value = UnMHTConfigManager.prefBranch.getCharPref (name);
                    break;
                case "int":
                    value = UnMHTConfigManager.prefBranch.getIntPref (name);
                    break;
            }
        }
        else {
            ; /* switch のインデント用 */
            switch (type) {
                case "bool":
                    UnMHTConfigManager.prefBranch.setBoolPref (name, value);
                    break;
                case "char":
                    UnMHTConfigManager.prefBranch.setCharPref (name, value);
                    break;
                case "int":
                    UnMHTConfigManager.prefBranch.setIntPref (name, value);
                    break;
            }
        }
        
        return value;
    },
    
    /**
     * 設定を書き込む
     *
     * @param  String type
     *         設定の種類
     *           "bool": bool
     *           "char": 文字列
     *           "int":  数値
     * @param  String name
     *         設定名
     * @param  Boolean/String/Number value
     *         既定値
     */
    setPref : function (type, name, value) {
        ; /* switch のインデント用 */
        switch (type) {
            case "bool":
                UnMHTConfigManager.prefBranch.setBoolPref (name, value);
                break;
            case "char":
                UnMHTConfigManager.prefBranch.setCharPref (name, value);
                break;
            case "int":
                UnMHTConfigManager.prefBranch.setIntPref (name, value);
                break;
        }
    },
    
    /**
     * 設定の変更のイベント
     *   nsIObserver.observe
     *
     * @param  nsISupports subject
     *         不明
     * @param  String topic
     *         通知の対象
     * @param  String data
     *         通知の内容
     */
    observe : function (subject, topic, data){
        if (topic == "nsPref:changed"){
            /* 設定の変更の場合 */
            
            /* 設定を取得する */
            UnMHTConfigManager.getConfigurationFromPreferencesAll ();
            UnMHTConfigManager.getConfigurationFromPreferences ();
            UnMHTUIManager.setPanelStatus ();
        }
    },
    
    /**
     * 全機能の ON／OFF について、設定を読み込む
     */
    getConfigurationFromPreferencesAll : function () {
        UnMHTConfigManager.loadPrefBranch ();
        
        UnMHT.enableAll
        = UnMHTConfigManager
        .initPref ("bool", "unmht.all", true);
        if (UnMHT.isThunderbird) {
            UnMHT.enableAll = true;
        }
    },
    
    /**
     * ステータスバー、ツールバーのパネルについて、設定を読み込む
     */
    getConfigurationFromPreferencesPanel : function () {
        UnMHTConfigManager.loadPrefBranch ();
        
        UnMHT.enableToolbarPreferences
        = UnMHTConfigManager
        .initPref ("bool", "unmht.toolbar.preferences", false);
        if (UnMHT.isThunderbird) {
            UnMHT.enableToolbarPreferences = false;
        }
        
        UnMHT.enableStatusbarPreferences
        = UnMHTConfigManager
        .initPref ("bool", "unmht.statusbar.preferences", true);
    },
    
    /**
     * 各種設定を読み込む
     */
    getConfigurationFromPreferences : function () {
        UnMHTConfigManager.loadPrefBranch ();
        
        UnMHT.enableMemoryCache
        = UnMHTConfigManager
        .initPref ("bool", "unmht.memorycache", true);
        if (Components.classes ["@mozilla.org/pipe;1"] == undefined) {
            UnMHT.enableMemoryCache = false;
        }
        UnMHT.enableNolimit
        = UnMHTConfigManager
        .initPref ("bool", "unmht.nolimit", true);
        UnMHT.enableFastExtract
        = UnMHTConfigManager
        .initPref ("bool", "unmht.fast_extract", false);
        
        UnMHT.enableFilter
        = UnMHTConfigManager
        .initPref ("bool", "unmht.filter", true);
        
        UnMHT.filterList = new Array ();
        var tmp
        = UnMHTConfigManager
        .initPref ("char", "unmht.filter.list", "");
        if (tmp != "") {
            /* 値を解析するだけなので代入はしない */
            tmp.replace
                (/([^&,]*)&([^&,]*)&([^&,]*),?/g,
                 function (matched, type, pattern, r) {
                    type = unescape (type);
                    pattern = unescape (pattern);
                    r = unescape (r) == "o";
                    if (r) {
                        pattern = new RegExp (pattern);
                    }
                    
                    UnMHT.filterList
                        .push (new Array (type,
                                          pattern,
                                          r));
                    
                    return "";
                });
        }
        
        UnMHT.cacheExpire
        = UnMHTConfigManager
        .initPref ("int",  "unmht.cache_expire", 5)
        * 60000;
        UnMHT.enableCacheExpire
        = UnMHTConfigManager
        .initPref ("bool", "unmht.cache_expire.enabled", true)
        
        UnMHT.enableSkipPPTWarning
        = UnMHTConfigManager
        .initPref ("bool", "unmht.skip_ppt_warning", false)
        
        UnMHT.openMultiple
        = UnMHTConfigManager
        .initPref ("char", "unmht.open_multiple", "tabs")
        
        UnMHT.saveFilename
        = UnMHTConfigManager
        .initPref ("char", "unmht.save.filename", "leafname");
        
        var value;

        value
        = UnMHTConfigManager
        .initPref ("char", "unmht.save.filename.custom", "%FILENAME%");
        UnMHT.saveFilenameCustom = unescape (value);
        
        value
        = UnMHTConfigManager
        .initPref ("char", "unmht.save.filename.custom.am", "a.m.");
        UnMHT.saveFilenameCustomAM = unescape (value);
        
        value
        = UnMHTConfigManager
        .initPref ("char", "unmht.save.filename.custom.pm", "p.m.");
        UnMHT.saveFilenameCustomPM = unescape (value);
        
        if (UnMHT.isThunderbird) {
            UnMHT.saveFilename = "title";
        }
        
        UnMHT.enableSaveContextMenu
        = UnMHTConfigManager
        .initPref ("bool", "unmht.save.contextmenu", true);

        UnMHT.enableSaveShortcut
        = UnMHTConfigManager
        .initPref ("bool", "unmht.save.shortcut", false);
        
        value
        = UnMHTConfigManager
        .initPref ("char", "unmht.save.shortcut.keycode",
                   "VK_S");
        value
        = unescape (value);
        UnMHT.saveShortcutKeycode
        = Components.interfaces.nsIDOMKeyEvent ["DOM_" + value];
        
        UnMHT.saveShortcutModifiersAlt
        = UnMHTConfigManager
        .initPref ("bool",
                   "unmht.save.shortcut.modifiers.alt",
                   true);
        UnMHT.saveShortcutModifiersCtrl
        = UnMHTConfigManager
        .initPref ("bool",
                   "unmht.save.shortcut.modifiers.ctrl",
                   true);
        UnMHT.saveShortcutModifiersMeta
        = UnMHTConfigManager
        .initPref ("bool",
                   "unmht.save.shortcut.modifiers.meta",
                   false);
        UnMHT.saveShortcutModifiersShift
        = UnMHTConfigManager
        .initPref ("bool",
                   "unmht.save.shortcut.modifiers.shift",
                   false);
    }
};

/**
 * UI 管理
 */
var UnMHTUIManager = {
    prefDialog : null, /* ChromeWindow  設定ダイアログ */
    
    scrapBookData : new Object (), /* Object  ScrapBook のデータ */
    
    /**
     * 設定ダイアログを開く
     *
     * @param  Event event
     *         対象のイベント
     * @param  Boolean fromToolbar
     *         ツールバーからか
     */
    showPreferences : function (event, fromToolbar) {
        if (("button" in event && event.button != 0)
            || event.ctrlKey || event.shiftKey
            || event.altKey || event.metaKey) {
            return;
        }
        
        if (fromToolbar
            && event.target
            && event.target.nodeName
            && event.target.nodeName.match (/menuitem/i)) {
            return;
        }
        
        try {
            if (UnMHTUIManager.prefDialog != null) {
                if (!UnMHTUIManager.prefDialog.closed) {
                    UnMHTUIManager.prefDialog.focus ();
                    return;
                }
            }
        }
        catch (e) {
            UnMHTUIManager.prefDialog = null;
        }
        var optionsURL = "chrome://unmht/content/options.xul";
        var features = "chrome,titlebar,toolbar,centerscreen,resizable";
        UnMHTUIManager.prefDialog = openDialog (optionsURL, "", features);
        
        if (Components.interfaces.nsIPrefBranch2 == undefined) {
            UnMHTUIManager.prefDialog.addEventListener
                ("unload",
                 function () {
                    UnMHTUIManager.setPanelStatus ();
                }, false);
        }
    },
    
    /**
     * ツールバーーのメニューを設定する
     */
    setToolbarPopup : function () {
        var menuitem;
        
        var targetDocument;
        var savable = true;
        
        if (!UnMHT.isThunderbird) {
            var tabbrowser = document.getElementById ("content");
            targetDocument = tabbrowser.contentDocument;
        }
        else {
            var messagepane = document.getElementById ("messagepane");
            targetDocument = messagepane.contentDocument;
            
            var messagepanebox = document.getElementById ("messagepanebox");
            if (messagepanebox.collapsed) {
                savable = false;
            }
        }
        
        if (savable && UnMHT.isSavable (targetDocument)) {
            menuitem = document.getElementById ("unmht-toolbar-menuitem-save");
            if (menuitem) {
                menuitem.setAttribute ("disabled", "false");
            }
        }
        else {
            menuitem = document.getElementById ("unmht-toolbar-menuitem-save");
            if (menuitem) {
                menuitem.setAttribute ("disabled", "true");
            }
        }
    },
    
    /**
     * ステータスバーのメニューを設定する
     */
    setStatusbarPopup : function () {
        var menuitem;
        
        menuitem = document.getElementById ("unmht-statusbar-popup-all");
        if (menuitem) {
            if (UnMHT.enableAll) {
                menuitem.label
                    = UnMHT.messages.GetStringFromName ("turnoff");
            }
            else {
                menuitem.label
                    = UnMHT.messages.GetStringFromName ("turnon");
            }
        }
        
        var targetDocument;
        var savable = true;
        
        if (!UnMHT.isThunderbird) {
            var tabbrowser = document.getElementById ("content");
            targetDocument = tabbrowser.contentDocument;
        }
        else {
            var messagepane = document.getElementById ("messagepane");
            targetDocument = messagepane.contentDocument;
            
            var messagepanebox = document.getElementById ("messagepanebox");
            if (messagepanebox.collapsed) {
                savable = false;
            }
        }
        
        if (savable && UnMHT.isSavable (targetDocument)) {
            menuitem
            = document.getElementById ("unmht-statusbar-menuitem-save");
            if (menuitem) {
                menuitem.hidden = false;
            }
        }
        else {
            menuitem
                = document.getElementById ("unmht-statusbar-menuitem-save");
            if (menuitem) {
                menuitem.hidden = true;
            }
        }
    },
    
    /**
     * ファイルメニューを設定する
     *
     * @param  Event event
     *         対象のイベント
     */
    setFileMenuPopup : function (event) {
        var tabbrowser = document.getElementById ("content");
        var targetDocument = tabbrowser.contentDocument;
        
        if (UnMHT.isSavable (targetDocument)) {
            var command = document.getElementById ("unmht-command-save");
            if (command) {
                command.setAttribute ("disabled", "false");
            }
        }
        else {
            var command = document.getElementById ("unmht-command-save");
            if (command) {
                command.setAttribute ("disabled", "true");
            }
        }
    },
    
    /**
     * 全機能の ON／OFF を切り替える
     */
    switchDisabled : function () {
        UnMHT.enableAll
        = !UnMHTConfigManager.initPref ("bool", "unmht.all", true);
        UnMHTConfigManager.prefBranch.setBoolPref ("unmht.all",
                                                   UnMHT.enableAll);
        
        UnMHTUIManager.setPanelStatus ();
    },
    
    /**
     * キャッシュを開く
     */
    openCache : function () {
        var browser = document.getElementById ("content");
        var newTab
        = browser.addTab (UnMHT.protocolHandler.enUnMHTURI ("cache:"), null);
        browser.selectedTab = newTab;
    },
    
    /**
     * キャッシュをクリア
     */
    confirmClearCache : function () {
        if (confirm (UnMHT.messages.GetStringFromName
                     ("confirm_clear_cache"))) {
            UnMHT.clearCache (0, true);
        }
    },
    
    /**
     * ScrapBook のポップアップを設定する
     *
     * @param  Event event
     *         対象のイベント
     */
    setScrapBookPopup : function (event) {
        var children = document.popupNode;
        var tree = children;
        while (tree) {
            if (tree.nodeName.toLowerCase () == "tree") {
                break;
            }
            tree = tree.parentNode;
        }
        if (!tree) {
            return;
        }
        
        var resource = tree.builderView.getResourceAtIndex (tree.currentIndex);
        
        UnMHTUIManager.scrapBookData ["source"]
        = sbDataSource.getProperty (resource, "source");
        UnMHTUIManager.scrapBookData ["title"]
        = sbDataSource.getProperty (resource, "title");
        UnMHTUIManager.scrapBookData ["id"]
        = sbDataSource.getProperty (resource, "id");
        UnMHTUIManager.scrapBookData ["dir"]
        = sbCommonUtils.getContentDir (UnMHTUIManager.scrapBookData ["id"]);
        UnMHTUIManager.scrapBookData ["charset"]
        = sbDataSource.getProperty (resource, "chars");
        
        var menuitem
        = tree.ownerDocument.getElementById ("unmht-scrapbook-save");
        if (UnMHTUIManager.scrapBookData ["source"]) {
            menuitem.hidden = false;
        }
        else {
            menuitem.hidden = true;
        }
    },
    
    /**
     * 保存
     *
     * @param  Boolean isScrapBook
     *         ScrapBook 使用か
     */
    save : function (isScrapBook) {
        var targetDocument;
        
        if (!UnMHT.isThunderbird) {
            var tabbrowser = document.getElementById ("content");
            targetDocument = tabbrowser.contentDocument;
        }
        else {
            var messagepane = document.getElementById ("messagepane");
            targetDocument = messagepane.contentDocument;
        }
        
        var filename = UnMHTUIManager.getFilename (targetDocument, isScrapBook);
        filename += ".mht";
        
        var current, original;
        var index;
        var currentIndex, originalIndex;
        
        current = true;
        original = true;
        
        var lastType
        = UnMHTConfigManager
        .initPref ("char", "unmht.save.type", "current");
        
        if (isScrapBook) {
            current = false;
        }
        
        if (UnMHT.isThunderbird) {
            original = false;
        }
        
        var filePicker
        = Components.classes ["@mozilla.org/filepicker;1"]
        .createInstance (Components.interfaces.nsIFilePicker);
        var mode;
        filePicker.init (window,
                         UnMHT.messages.GetStringFromName ("save_title"),
                         Components.interfaces.nsIFilePicker.modeSave);
        
        index = 0;
        if (current) {
            filePicker.appendFilter
                (UnMHT.messages.GetStringFromName ("filetype")
                 + " " + UnMHT.messages.GetStringFromName ("filetype_current"),
                 "*.mht");
            currentIndex = index;
            index ++;
        }
        else {
            currentIndex = -1;
        }
        if (original) {
            filePicker.appendFilter
                (UnMHT.messages.GetStringFromName ("filetype")
                 + " " + UnMHT.messages.GetStringFromName ("filetype_original"),
                 "*.mht");
            originalIndex = index;
            index ++;
        }
        else {
            originalIndex = -2;
        }
        
        (UnMHT.messages.GetStringFromName ("filetype")
         + " " + UnMHT.messages.GetStringFromName ("filetype_original"),
         "*.mht");
        filePicker.defaultString = filename;
        if (lastType == "current") {
            filePicker.filterIndex = currentIndex;
        }
        else if (lastType == "original") {
            filePicker.filterIndex = originalIndex;
        }
        
        var ret = filePicker.show ();
        if (ret == Components.interfaces.nsIFilePicker.returnOK ||
            ret == Components.interfaces.nsIFilePicker.returnReplace) {
            var useCurrentState = (filePicker.filterIndex == currentIndex);
            
            if (filePicker.filterIndex == currentIndex) {
                UnMHTConfigManager
                    .setPref ("char", "unmht.save.type", "current");
            }
            else if (filePicker.filterIndex == originalIndex) {
                UnMHTConfigManager
                    .setPref ("char", "unmht.save.type", "original");
            }
            
            var file
                = filePicker.file
                .QueryInterface (Components.interfaces.nsILocalFile);
            
            file.leafName = UnMHTFormatter.validateFileName (file.leafName);
            
            if (!file.leafName.match (/\.mht$/)) {
                var path = file.path + ".mht";
                file
                    = Components.classes ["@mozilla.org/file/local;1"]
                    .createInstance (Components.interfaces.nsILocalFile);
                file.initWithPath (path);
            }
            
            var pageURL = "chrome://unmht/content/save.xul";
            var features = "chrome,titlebar,centerscreen";
            
            openDialog (pageURL, "", features,
                        [file, targetDocument, useCurrentState,
                         isScrapBook, UnMHTUIManager.scrapBookData]);
        }
    },
    
    /**
     * まとめて保存
     */
    savemulti : function () {
        var pageURL = "chrome://unmht/content/savemulti.xul";
        var features = "chrome,titlebar,centerscreen";
        
        var targetWindow
        = Components.classes ["@mozilla.org/appshell/window-mediator;1"]
        .getService (Components.interfaces.nsIWindowMediator)
        .getMostRecentWindow ("navigator:browser");
        
        openDialog (pageURL, "", features,
                    [targetWindow, UnMHT.saveFilename]);
    },
    
    /**
     * 保存する際のファイル名を取得する
     *
     * @param  HTMLDocument targetDocument
     *         対象のドキュメント
     * @param  Boolean isScrapBook
     *         ScrapBook 使用か
     */
    getFilename : function (targetDocument, isScrapBook) {
        var filename;
        var title, uri;
        
        filename = "";
        
        if (isScrapBook) {
            uri = UnMHTUIManager.scrapBookData ["source"];
            title = UnMHTUIManager.scrapBookData ["title"];
        }
        else {
            uri = targetDocument.location.href;
            title = targetDocument.title;
        }
        
        if (uri.match (/[^\?]+\/([^\/\?]+)(\?.+)?(#.+)?$/)) {
            filename = RegExp.$1;
            if (filename.match (/^(.+)\.[^\.]+$/)) {
                filename = RegExp.$1;
            }
            else {
                filename = filename;
            }
        }
        else {
            filename = "index";
        }
        
        if (UnMHT.saveFilename == "title") {
            var tmp = UnMHTFormatter.validateFileName (title);
            
            if (tmp) {
                filename = tmp;
            }
        }
        else if (UnMHT.saveFilename == "custom") {
            var pattern = UnMHT.saveFilenameCustom;
            var am = UnMHT.saveFilenameCustomAM;
            var pm = UnMHT.saveFilenameCustomPM;
            
            filename
            = UnMHTFormatter.format (pattern, title, filename, uri, am, pm);
        }
        else {
            filename = UnMHTFormatter.validateFileName (filename);
        }
        
        return filename;
    },
    
    /**
     * サイトを開く
     */
    openWebsite : function () {
        var browser = document.getElementById ("content");
        var locale = "ja-JP";
        try {
            var name = "general.useragent.locale";
            locale = UnMHTConfigManager.prefBranch.getCharPref (name);
        }
        catch (e) {
        }
        var newTab;
        if (locale.match (/^ja/)) {
            newTab = browser.addTab ("http://www.unmht.org/unmht/", null);
        }
        else {
            newTab
            = browser.addTab ("http://www.unmht.org/unmht/en_index.html", null);
        }
        browser.selectedTab = newTab;
    },
    
    /**
     * ステータスバー、ツールバーのパネルを表示する
     */
    showPanel : function () {
        UnMHTConfigManager.getConfigurationFromPreferencesPanel ();
        
        if (UnMHT.enableToolbarPreferences) {
            var style = -1;
            if (UnMHTConfigManager.prefBranch
                .prefHasUserValue ("browser.chrome.toolbar_style")) {
                style
                    = UnMHTConfigManager.prefBranch
                    .getIntPref ("browser.chrome.toolbar_style");
            }
            var navbar;
            var button;
            var inner;
            navbar = document.getElementById ("nav-bar");
            inner = document.getElementById ("nav-bar-inner");
            if (navbar && inner) {
                if (UnMHT.enableToolbarPreferences) {
                    button = document.createElement ("toolbarbutton");
                    var id = "";
                    if (style != 1) {
                        id = "unmht-toolbarbutton-preferences-image";
                    }
                    else {
                        id = "unmht-toolbarbutton-preferences-text";
                    }
                    button.setAttribute ("id", id);
                    button.setAttribute ("oncommand",
                                         "UnMHTUIManager.showPreferences (arguments [0], true);");
                    button.setAttribute ("class", "toolbarbutton-1");
                    button.setAttribute ("status", UnMHT.enableAll);
                    if (style != 0) {
                        button.setAttribute ("label", "UnMHT");
                    }
                    button.setAttribute ("tooltiptext", "UnMHT");
                    
                    navbar.insertBefore (button, inner);
                }
            }
        }
        
        var panel;
        panel = document.getElementById ("unmht-statusbarpanel-preferences");
        if (panel) {
            panel.hidden = !UnMHT.enableStatusbarPreferences;
        }
        
        var popup;
        popup = document.getElementById ("unmht-statusbar-popup");
        if (!popup) {
            /* Mozilla Suite では mainPopupSet が無いためオーバーレイできない */
            
            var mainWindow = document.getElementById ("main-window");
            if (mainWindow) {
                var targetDocument = mainWindow.ownerDocument;
                
                var popupset = targetDocument.createElement ("popupset");
                
                popup = targetDocument.createElement ("popup");
                popup.id = "unmht-statusbar-popup";
                popup.setAttribute ("position", "after_start");
                popup.setAttribute ("onpopupshowing",
                                    "UnMHTUIManager.setStatusbarPopup ();");
                
                var menuitem;
                var menuseparator;
                var label, command;
                
                /* 読み込めていない事があるので読み直す */
                UnMHT.messages
                    = Components.classes ["@mozilla.org/intl/stringbundle;1"]
                    .getService (Components.interfaces.nsIStringBundleService)
                    .createBundle ("chrome://unmht/locale/unmht.properties");
                
                label
                    = UnMHT.messages.GetStringFromName ("turnoff");
                command = "UnMHTUIManager.switchDisabled ();";
                menuitem = targetDocument.createElement ("menuitem");
                menuitem.id = "unmht-statusbar-popup-all";
                menuitem.setAttribute ("label", label);
                menuitem.setAttribute ("oncommand", command);
                popup.appendChild (menuitem);
                
                menuseparator = targetDocument.createElement ("menuseparator");
                menuseparator.id = "unmht-statusbar-menuitem-separator";
                popup.appendChild (menuseparator);
                
                label
                    = UnMHT.messages.GetStringFromName ("extract");
                Command = "UnMHT.loadMHTFromFocusedWindow (1);";
                menuitem = targetDocument.createElement ("menuitem");
                menuitem.setAttribute ("label", label);
                menuitem.setAttribute ("oncommand", command);
                popup.appendChild (menuitem);
                
                label
                    = UnMHT.messages.GetStringFromName ("unextract");
                command = "UnMHT.loadMHTFromFocusedWindow (2);";
                menuitem = targetDocument.createElement ("menuitem");
                menuitem.setAttribute ("label", label);
                menuitem.setAttribute ("oncommand", command);
                popup.appendChild (menuitem);
                
                label
                    = UnMHT.messages.GetStringFromName ("showcache");
                command = "UnMHTUIManager.openCache ();";
                menuitem = targetDocument.createElement ("menuitem");
                menuitem.setAttribute ("label", label);
                menuitem.setAttribute ("oncommand", command);
                popup.appendChild (menuitem);
                
                label
                    = UnMHT.messages.GetStringFromName ("clearcache");
                command = "UnMHTUIManager.confirmClearCache ();";
                menuitem = targetDocument.createElement ("menuitem");
                menuitem.setAttribute ("label", label);
                menuitem.setAttribute ("oncommand", command);
                popup.appendChild (menuitem);
                
                menuseparator = targetDocument.createElement ("menuseparator");
                menuseparator.id = "unmht-statusbar-menuitem-separator2";
                popup.appendChild (menuseparator);
                
                if (Components.classes ["@mozilla.org/binaryinputstream;1"]
                    != undefined) {
                    label
                        = UnMHT.messages.GetStringFromName ("save_title");
                    command = "UnMHTUIManager.save (false);";
                    menuitem = targetDocument.createElement ("menuitem");
                    menuitem.setAttribute ("label", label);
                    menuitem.setAttribute ("oncommand", command);
                    popup.appendChild (menuitem);
                    
                    menuseparator
                        = targetDocument.createElement ("menuseparator");
                    menuseparator.id = "unmht-statusbar-menuitem-separator3";
                    popup.appendChild (menuseparator);
                }
                
                label
                    = UnMHT.messages.GetStringFromName ("openwebsite");
                command = "UnMHTUIManager.openWebsite ();";
                menuitem = targetDocument.createElement ("menuitem");
                menuitem.setAttribute ("label", label);
                menuitem.setAttribute ("oncommand", command);
                popup.appendChild (menuitem);
                
                popupset.appendChild (popup);
                
                mainWindow.appendChild (popupset);
            }
        }
    },
    
    /**
     * パネルのアイコンを、全機能の ON／OFF に合わせて切り替える
     */
    setPanelStatus : function () {
        UnMHTConfigManager.loadPrefBranch ();
        
        var enableAll
        = UnMHTConfigManager
        .initPref ("bool", "unmht.all", true);
        
        var panel;
        if (enableAll) {
            panel
                = document.getElementById ("unmht-statusbarpanel-preferences");
            if (panel) {
                panel.setAttribute ("status", "enabled");
                var text = panel.getAttribute ("tooltiptext");
                if (text.indexOf (UnMHTVersion) == -1) {
                    panel.setAttribute ("tooltiptext",
                                        text + " " + UnMHTVersion);
                }
            }
            panel
                = document.getElementById ("unmht-toolbarbutton-preferences");
            if (panel) {
                panel.setAttribute ("status", "enabled");
            }
            panel
                = document.getElementById ("unmht-toolbarbutton-save");
            if (panel) {
                panel.setAttribute ("status", "enabled");
            }
            panel
                = document
                .getElementById ("unmht-toolbarbutton-preferences-image");
            if (panel) {
                panel.setAttribute ("status", "enabled");
            }
        }
        else {
            panel
            = document.getElementById ("unmht-statusbarpanel-preferences");
            if (panel) {
                panel.setAttribute ("status", "disabled");
            }
            panel
            = document.getElementById ("unmht-toolbarbutton-preferences");
            if (panel) {
                panel.setAttribute ("status", "disabled");
            }
            panel
            = document.getElementById ("unmht-toolbarbutton-save");
            if (panel) {
                panel.setAttribute ("status", "disabled");
            }
            panel
            = document.getElementById ("unmht-toolbarbutton-preferences-image");
            if (panel) {
                panel.setAttribute ("status", "disabled");
            }
        }
    }
};

/**
 * リロードイベントをキャッチするリスナ
 *   Inherits From: nsISHistoryListener
 */
function UnMHTSHistoryListener () {
}
UnMHTSHistoryListener.prototype = {
    targetWindow : null, /* Window  対象のウィンドウ */
    
    /**
     * データを開放する
     */
    destruct : function () {
        try {
            this.targetWindow
            .QueryInterface (Components.interfaces.nsIInterfaceRequestor)
            .getInterface (Components.interfaces.nsIWebNavigation)
            .sessionHistory.removeSHistoryListener (this);
        }
        catch (e) {
        }
        this.targetWindow = null;
    },
    
    /**
     * インターフェースの要求
     *   nsISupports.QueryInterface
     *
     * @param  nsIIDRef iid
     *         インターフェース ID
     * @throws Components.results.NS_NOINTERFACE
     * @return nsISHistoryListener
     *         this
     */
    QueryInterface : function (iid) {
        if (iid.equals (Components.interfaces.nsISupports)
            || iid.equals (Components.interfaces.nsISupportsWeakReference)
            || iid.equals (Components.interfaces.nsISHistoryListener)) {
            return this;
        }
        
        throw Components.results.NS_NOINTERFACE;
    },
    
    /**
     * 戻るイベント
     *   nsISHistoryListener.OnHistoryGoBack
     *
     * @param  nsIURI backURI
     *         戻る先の URI
     * @return Boolean
     *         続けるかどうか
     */
    OnHistoryGoBack : function (backURI) {
        return true;
    },
    
    /**
     * 進むイベント
     *   nsISHistoryListener.OnHistoryGoForward
     *
     * @param  nsIURI forwardURI
     *         進む先の URI
     * @return Boolean
     *         続けるかどうか
     */
    OnHistoryGoForward : function (forwardURI) {
        return true;
    },
    
    /**
     * 移動イベント
     *   nsISHistoryListener.OnHistoryGotoIndex
     *
     * @param  Number index
     *         移動先のインデックス
     * @param  nsIURI gotoURI
     *         移動先の URI
     * @return Boolean
     *         続けるかどうか
     */
    OnHistoryGotoIndex : function (index, gotoURI) {
        return true;
    },
    
    /**
     * 項目追加イベント
     *   nsISHistoryListener.OnHistoryNewEntry
     *
     * @param  nsIURI newURI
     *         追加する URI
     */
    OnHistoryNewEntry : function (newURI) {
        return true;
    },
    
    /**
     * 項目削除イベント
     *   nsISHistoryListener.OnHistoryPurge
     *
     * @param  Number index
     *         削除する数
     * @return Boolean
     *         続けるかどうか
     */
    OnHistoryPurge : function (numEntries) {
        return true;
    },
    
    /**
     * リロードイベント
     *   nsISHistoryListener.OnHistoryReload
     * ファイルを展開し直す
     *
     * @param  nsIURI reloadURI
     *         リロードする URI
     * @param  Number reloadFlags
     *         リロード方法
     * @return Boolean
     *         続けるかどうか
     */
    OnHistoryReload : function (reloadURI, reloadFlags) {
        var nav
        = this.targetWindow
        .QueryInterface (Components.interfaces.nsIInterfaceRequestor)
        .getInterface (Components.interfaces.nsIWebNavigation);
        
        if (UnMHT.protocolHandler.isUnMHTURI (reloadURI.spec)) {
            var uri
                = Components.classes ["@mozilla.org/network/standard-url;1"]
                .createInstance (Components.interfaces.nsIURI);
            var param = UnMHT.protocolHandler.getUnMHTURIParam (reloadURI.spec);
            uri.spec = param.original;
            
            UnMHT.loadMHT (uri, this.targetWindow,
                           false,         /* ドキュメント無し */
                           true,          /* 履歴は置き換える */
                           0,             /* 展開は設定に任せる */
                           param.refName, /* 現在開いているファイルを開く */
                           false);        /* キャッシュは使用しない */
            return false;
        }
        
        return true;
    }
};

/**
 * ファイルダウンロードの進行状況のリスナ
 *   Inherits From: nsIWebProgressListener
 */
function UnMHTProgressListener () {
}
UnMHTProgressListener.prototype = {
    uri : null,          /* nsIURI  開く URI */
    targetWindow : null, /* Window  表示するウィンドウ */
    
    hasDocument : false, /* Boolean  ドキュメントに内容を持っているか */
    replace : false,     /* Boolean  履歴を置き換えるかどうか */
    extract : false,     /* Boolean  展開するかどうか */
    refName : "",        /* String  対象のファイル */
    
    filename : "",       /* String  保存するファイル名 */
    extractName : "",    /* String  展開先のディレクトリの名前 */
    
    /**
     * インターフェースの要求
     *   nsISupports.QueryInterface
     *
     * @param  nsIIDRef iid
     *         インターフェース ID
     * @throws Components.results.NS_NOINTERFACE
     * @return nsIWebProgressListener
     *         this
     */
    QueryInterface : function (iid) {
        if (iid.equals (Components.interfaces.nsISupports)
            || iid.equals (Components.interfaces.nsIWebProgressListener)) {
            return this;
        }
        
        throw Components.results.NS_NOINTERFACE;
    },
    
    /**
     * 監視ウィンドウのロケーションが変わった時のイベント
     *   nsIWebProgressListener.onLocationChange
     * 未使用
     */
    onLocationChange : function (webProgress, request, location) {
    },
    
    /**
     * 進行状況が変わった時のイベント
     *   nsIWebProgressListener.onProgressChange
     * 未使用
     */
    onProgressChange : function (webProgress , request,
                                curSelfProgress, maxSelfProgress,
                                curTotalProgress, maxTotalProgress) {
    },
    
    /**
     * プロトコルのセキュリティ設定が変わった時のイベント
     *   nsIWebProgressListener.onSecurityChange
     * 未使用
     */
    onSecurityChange : function (webProgress, request, state) {
    },
    
    /**
     * 状況が変わった時のイベント
     *   nsIWebProgressListener.onStateChange
     * 終了したらファイルを展開する
     *
     * @param  nsIWebProgress webProgress
     *         呼び出し元
     * @param  nsIRequest request
     *         状況の変わったリクエスト
     * @param  Number stateFlags
     *         変わった状況のフラグ
     * @param  nsresult status
     *         エラーコード
     */
    onStateChange : function (webProgress, request, stateFlags, status) {
        var httpStatus = 200;
        try {
            /* HTTP の場合ステータスをチェックする */
            httpStatus
                = request.QueryInterface (Components.interfaces.nsIHttpChannel)
                .responseStatus;
        }
        catch (e) {
            /* HTTP でない場合はデフォルトの 200 のまま */
        }
        
        if (stateFlags
            & Components.interfaces.nsIWebProgressListener.STATE_STOP) {
            if (httpStatus == 200) {
                /* 転送が終了したら
                 * (HTTP の場合は 200 ならば) */
                UnMHT.loadMHTFromFile (this.uri, this.targetWindow,
                                       this.hasDocument,
                                       this.replace,
                                       this.extract,
                                       this.refName,
                                       this.filename, this.extractName);
                var targetFile = UnMHTFileManager.initFile (this.filename);
                if (targetFile.exists ()) {
                    targetFile.remove (true);
                }
            }
            else {
                /* ファイルが見付からなかった場合 */
                if (this.hasDocument) {
                    UnMHT.loadMHTFromDocument (this.uri, this.targetWindow,
                                               true,
                                               this.replace,
                                               this.extract,
                                               this.refName);
                }
                else {
                    UnMHT.showErrorPage (this.targetWindow, this.uri.spec);
                }
            }
        }
    },
    
    /**
     * ステータスバーに表示するメッセージが変わった時のイベント
     *   nsIWebProgressListener.onStatusChange
     * 未使用
     */
    onStatusChange : function (webProgress, request, status, message) {
    }
};

var UnMHT_isThunderbird = false;
try {
    if (Components.classes ["@mozilla.org/xre/app-info;1"]
        .getService (Components.interfaces.nsIXULAppInfo).ID
        == "{3550f703-e582-4d05-9a08-453d09bdfdc6}") {
        UnMHT_isThunderbird = true;
    }
} catch (e) {}

if (UnMHT_isThunderbird) {
    /* Thunderbird */
    UnMHT.protocolHandler = {
        enUnMHTURI : function (uri) {
            return uri;
        },
        isUnMHTURI : function (uri) {
            return false;
        },
        deUnMHTURI : function (uri) {
            return uri;
        },
        getUnMHTURIParam : function (uri) {
            return null;
        }
    };
}
else {
    UnMHT.protocolHandler
        = Components.classes ["@mozilla.org/network/protocol;1?name=unmht"]
        .getService (Components.interfaces.arIUnMHTProtocolHandler);
}

/* 古い Mozilla Suite では最初のイベントリスナが無視されるので 2 つ登録する */
window.addEventListener ("load",
                         function () {
                             UnMHT.onLoad ();
                         }, false);
window.addEventListener ("load",
                         function () {
                             UnMHT.onLoad ();
                         }, false);

window.addEventListener ("unload",
                         function () {
                             UnMHT.onUnload ();
                         }, false);
window.addEventListener ("unload",
                         function () {
                             UnMHT.onUnload ();
                         }, false);
